mode='print'
mode='screen'


  itype=1 & citype='_triangular' & fwhm=1.0 & cfwhm='_fwhm100'	; Greece campaign com (335-345nm)
;  itype=1 & citype='_triangular' & fwhm=0.60 & cfwhm='_fwhm060'	; GSFC Double Brewer #171 in low mask range (303-320nm)
;    itype=1 & citype='_triangular' & fwhm=0.50 & cfwhm='_fwhm050'	; Default Brewer slit
;    itype=3 & citype='_gaussian' & fwhm=0.3800 & cfwhm='_fwhm038'	; OMI FWHM=0.38nm to use directly  with the new slitavg.pro 
;    itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro to convert from SCIA to OMI resolution
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian


input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;mszat=0 &  read_coe, '/BSBR_V8.DAT.ref',1, 1601,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ; V8
;       same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;read_coe, './BSBR_V7.DAT',1, 1075,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ;       V7
;       same as: '../TOMRAD/v2.22/coe.dat.old',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE


SO2_TEMP='223' ;	Ib:  read SO2 abs coefficients at specific temperature
read_so2,'./SO2/bogumil2000_'+SO2_TEMP,'SCIA_xsection',2,1402,35,SO2_TEMP,'nm',lv_tso2,gammav_tso2


input_solar_choice:              ;      Ic. READ MONOCHOMATIC VACUUM ETS values
solar_name='' &  read,'Input monochromatic solar referemce choice ''mayer''  or ''chance'': ',solar_name
CASE solar_name OF
;	Ia read F0 at vac solar wavelengths
'mayer'	: read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv
'chance': read_solar,'./ETS/kchance_295_325.txt'    ,  1.0, 275,1, 3001,l_solv,ml_solv,solv
ELSE:  begin & print,'not a valid name' & goto,input_solar_choice & end
ENDCASE

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)
betv_s(*) = interpol(betv_t,lv_t,l_solv)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)

;	III. Write Brewer slit averaged coeficients to the file for Brewer low slit mask center positions only

close,31  & openw,31,'Mario_coe_eff_'+ozone_name+citype+cfwhm
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
print,31
printf,31,'Effective  absorption coefficients [atm-cm-1]                   


skip:
slit=''  & read,'input Brewer slit mask (l1..l6, m1.., h1..): ',slit
printf,31,'Slit number: 	',slit                                
;                                       PLOT
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='Brewer_'+slit+'.ps'
endelse


; Below are wavelength-centers (air-wavelengths) and slit functions for the low (=ozone) wavelength range (303-320nm)
;and medium wavelength range (327-343nm). In these 2 ranges we do the polarized sky radiance measurements in the principal plane since 2005-4-21.
; Low range wavelength centers slit #1 to slit #6 [nm]
; 303.216  306.315  310.056  313.498  316.794  319.983
;The wavelength-accuracy is 0.015nm (2sigma) for all wavelengths.
; You can use this number as a totally correlated wavelength uncertainty
; (i.e. if slit #1 is 0.01nm high, then all other slits are also 0.01nm high;
; this is because the dominant contribution is the grating-shift due to temperature,
; mechanical movement etc., which affects all wavelengths in the same way).

get_srf_brewer,slit,w_vac,f,err,w_vac_cent              ;  get Brewer SRF for slit  shifted to vac wavelengths
print,'w_vac_cent',w_vac_cent

;			PLOT

ozone=325.0             ; [DU]
pres_rel=1.0           ; Pressure, atm
airmass=3.0             ; airmass (molecular)
plot_srf_brewer,ozone,pres_rel,airmass,mode,slit,w_vac_cent,w_vac(0)-0.3,w_vac(n_elements(w_vac)-1)+0.3,w_vac,f,err,l_solv,ml_solv,solv,betv_s,rhov_s,c0v_s,c1v_s,c2v_s,gammav_s,$
tau_aer_eff,l_rad,e0,w_vac_eff,tau_ray_eff,rho_ray_eff,c0v_eff,c1v_eff,c2v_eff,tau_oz_eff,gammav_eff



printf,31,'slit_aver: w_vac_eff=',w_vac_eff	;       303.31071

printf,31,'slit_aver: e0      ',e0		; l1: e0=0.71175357
printf,31,'slit_aver: tau_ray_eff=',tau_ray_eff ;       0.83589443
printf,31,'slit_aver: rho_ray_eff=',rho_ray_eff ;     0.022828642
printf,31,'slit_aver: c0v_eff=',c0v_eff 	;       4.6246632
printf,31,'slit_aver: c1v_eff=',c1v_eff		;    0.0092505197
printf,31,'slit_aver: c2v_eff=',c2v_eff		;   4.0980549e-05
printf,31,'slit_aver: tau_oz_eff=',tau_oz_eff	;       1.3517834
printf,31,'slit_aver: gammav_eff=',gammav_eff	;       4.4540778
printf,31                                              

read,'Calculate coefficients for new slit? 1 - yes   2 - no: ',new_slit
if new_slit eq 1  then goto,skip
if mode ne 'screen' then device,/close


close, 31 


;		Raman input calculation for Brewer lower slit region (303-320):
;mchan=401
;chan_vac=0.1*findgen(mchan)+290.0	; wavelengths, [nm]
;chan=chan_vac	& print,chan_vac
;!Brewer #171 direct irradiance measurement at Goddard Space Flight Center, Maryland, USA 
;!Lat 38.983, Long -76.833, 90m a.s.l. 
;!Data provided by Alexander Cede, cede@gsfc.nasa.gov 
;!---------------------------------------------------------------------------------------------------------------
;!File created on 02-Nov-2006 15:13:15 
;!rd-routine, SZA~56
;!Date: 25-Oct-2006
;!---------------------------------------------------------------------------------------------------------------
;!wavelength[nm] irradiance[mW/m2/nm]  2sigma-noise[mW/m2/nm]    UT-time[hh] 
chan_vac=[ 335.100,$ 
335.600  ,$
336.100 ,$
336.600,$
337.100 ,$    
337.600  ,$  
338.100    ,$
338.600   ,$
339.100,$ 
339.600 ,$
340.100,$
340.600 ,$     
341.100  ,$   
341.600   ,$ 
342.100    ,$
342.600   ,$
343.100  ,$
343.600 ,$
344.100  ,$    
344.600   ,$  
345.100    ] 

mchan=n_elements(chan_vac)
print,mchan
print,chan_vac

chan=chan_vac

c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s(*)*solv(*))
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s(*)*solv(*))
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s(*)*solv(*))
       gamma(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s(*)*solv(*))

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s(*)*solv(*))
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s(*)*solv(*))
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma(il) = gamma(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor



;	II. Write slit-averaged ETS to file:


close,3    & openw,3, 'coes.alex'+citype+cfwhm
printf,3,'lambda Rayleigh King   Ozone Abs. Coe.  H2O     Flux  taum tauc  Refract. Index  albedo'
printf,3,' (um)  (1/atm)  Factor oz0      oz1 oz2 Abs Coe                  Aerosol  Cloud'
printf,3,'                       (1/atm-cm)                                 (x+iy) (x+iy)'                    
printf,3,mchan
	for il=0,mchan-1 do begin
	printf,3,1.E-03*chan(il),betv_c(il),1.0,c0v_c(il),c1v_c(il),c2v_c(il),0.0,1.00,0.0,0.0,1.5,0.0,1.3,.0,0.02,$
format='(f6.4,f7.4,f5.1,3e12.4,f4.1,f8.5,2f4.1,4f4.1,f7.2)'
	endfor
close,3

close,3    & openw,3, 'F0_alex'+citype+cfwhm
printf,3,mchan
	for il=0,mchan-1 do begin
printf,3,1.*chan(il),solv_c(il)                                                                                       
       format='(7e12.4)'
	endfor
close,3


;                                       PLOT
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='Brewer_'+slit+'.ps'
endelse


stop
end
