mode='print'
mode='screen'


    itype=1 & citype='_triangular' & fwhm=0.60 & cfwhm='_fwhm060'	; GSFC Double Brewer #171 in low mask range (303-320nm)
;    itype=1 & citype='_triangular' & fwhm=0.50 & cfwhm='_fwhm050'	; Default Brewer slit
;    itype=3 & citype='_gaussian' & fwhm=0.3800 & cfwhm='_fwhm038'	; OMI FWHM=0.38nm to use directly  with the new slitavg.pro 
;    itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro to convert from SCIA to OMI resolution
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian


input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;mszat=0 &  read_coe, '/BSBR_V8.DAT.ref',1, 1601,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ; V8
;       same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;read_coe, './BSBR_V7.DAT',1, 1075,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ;       V7
;       same as: '../TOMRAD/v2.22/coe.dat.old',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE


SO2_TEMP='223' ;	Ib:  read SO2 abs coefficients at specific temperature
read_so2,'./SO2/bogumil2000_'+SO2_TEMP,'SCIA_xsection',2,1402,35,SO2_TEMP,'nm',lv_tso2,gammav_tso2


input_solar_choice:              ;      Ic. READ MONOCHOMATIC VACUUM ETS values
solar_name='' &  read,'Input monochromatic solar referemce choice ''mayer''  or ''chance'': ',solar_name
CASE solar_name OF
;       Ia read F0 at vac solar wavelengths
'mayer' : read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv
	 ;read_solar,'./mayer_vac_ipmmi.txt', 275,      l_solv,ml_solv,solv
'chance': read_solar,'./ETS/kchance_295_325.txt'    ,  1.0, 275,1, 3001,l_solv,ml_solv,solv
ELSE:  begin & print,'not a valid name' & goto,input_solar_choice & end
ENDCASE



;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)
betv_s(*) = interpol(betv_t,lv_t,l_solv)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)

;	III. Write Brewer slit averaged coeficients to the file for Brewer low slit mask center positions only

close,31  & openw,31,'Brewer_coe_eff_'+ozone_name+citype+cfwhm
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
print,31
printf,31,'Effective  absorption coefficients [atm-cm-1]                   


skip:
slit=''  & read,'input Brewer slit mask (l1..l6, m1.., h1..): ',slit
printf,31,'Slit number: 	',slit                                
;                                       PLOT
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='Brewer_'+slit+'.ps'
endelse


; Below are wavelength-centers (air-wavelengths) and slit functions for the low (=ozone) wavelength range (303-320nm)
;and medium wavelength range (327-343nm). In these 2 ranges we do the polarized sky radiance measurements in the principal plane since 2005-4-21.
; Low range wavelength centers slit #1 to slit #6 [nm]
; 303.216  306.315  310.056  313.498  316.794  319.983
;The wavelength-accuracy is 0.015nm (2sigma) for all wavelengths.
; You can use this number as a totally correlated wavelength uncertainty
; (i.e. if slit #1 is 0.01nm high, then all other slits are also 0.01nm high;
; this is because the dominant contribution is the grating-shift due to temperature,
; mechanical movement etc., which affects all wavelengths in the same way).

get_srf_brewer,slit,w_vac,f,err,w_vac_cent              ;  get Brewer SRF for slit  shifted to vac wavelengths
print,'w_vac_cent',w_vac_cent

;			PLOT

ozone=315.0             ; [DU]
pres_rel=1.0           ; Pressure, atm
airmass=3.0             ; airmass (molecular)
plot_srf_brewer,ozone,pres_rel,airmass,mode,slit,w_vac_cent,w_vac(0)-0.3,w_vac(n_elements(w_vac)-1)+0.3,w_vac,f,err,l_solv,ml_solv,solv,betv_s,rhov_s,c0v_s,c1v_s,c2v_s,gammav_s,$
tau_aer_eff,l_rad,e0,w_vac_eff,tau_ray_eff,rho_ray_eff,c0v_eff,c1v_eff,c2v_eff,tau_oz_eff,gammav_eff



printf,31,'slit_aver: w_vac_eff=',w_vac_eff	;       303.31071

printf,31,'slit_aver: e0      ',e0		; l1: e0=0.71175357
printf,31,'slit_aver: tau_ray_eff=',tau_ray_eff ;       0.83589443
printf,31,'slit_aver: rho_ray_eff=',rho_ray_eff ;     0.022828642
printf,31,'slit_aver: c0v_eff=',c0v_eff 	;       4.6246632
printf,31,'slit_aver: c1v_eff=',c1v_eff		;    0.0092505197
printf,31,'slit_aver: c2v_eff=',c2v_eff		;   4.0980549e-05
printf,31,'slit_aver: tau_oz_eff=',tau_oz_eff	;       1.3517834
printf,31,'slit_aver: gammav_eff=',gammav_eff	;       4.4540778
printf,31                                              

read,'Calculate coefficients for new slit? 1 - yes   2 - no: ',new_slit
if new_slit eq 1  then goto,skip
if mode ne 'screen' then device,/close


close, 31 


;		Raman input calculation for Brewer lower slit region (303-320):
;mchan=401
;chan_vac=0.1*findgen(mchan)+290.0	; wavelengths, [nm]
;chan=chan_vac	& print,chan_vac
;!Brewer #171 direct irradiance measurement at Goddard Space Flight Center, Maryland, USA 
;!Lat 38.983, Long -76.833, 90m a.s.l. 
;!Data provided by Alexander Cede, cede@gsfc.nasa.gov 
;!---------------------------------------------------------------------------------------------------------------
;!File created on 02-Nov-2006 15:13:15 
;!rd-routine, SZA~56
;!Date: 25-Oct-2006
;!---------------------------------------------------------------------------------------------------------------
;!wavelength[nm] irradiance[mW/m2/nm]  2sigma-noise[mW/m2/nm]    UT-time[hh] 
chan_air=[ 300.023,$ 
300.126  ,$
300.228 ,$
300.324,$
300.426 ,$    
300.529  ,$  
300.624    ,$
300.726   ,$
300.828,$ 
300.923 ,$
301.026,$
301.128 ,$     
301.230  ,$   
301.325   ,$ 
301.427    ,$
301.529   ,$
301.624  ,$
301.726 ,$
301.828  ,$    
301.930   ,$  
302.025    ,$
302.127    ,$
302.229   ,$
302.323  ,$
302.425 ,$
302.527,$
302.629 ,$     
302.723  ,$   
302.825   ,$ 
302.927    ,$
303.028   ,$
303.123  ,$
303.224 ,$
303.326,$
303.42,$
303.529,$   
303.623 ,$    
303.725  ,$  
303.826   ,$
303.927   ,$
304.029    ,$ 
304.123     ,$
304.224    ,$
304.325   ,$
304.427  ,$
304.528 ,$
304.622,$
304.723 ,$      
304.824  ,$     
304.925   ,$    
305.026    ,$   
305.127     ,$ 
305.221      ,$
305.322     ,$
305.422     ,$
305.523    ,$
305.624   ,$
305.725    ,$  
305.826     ,$
305.926     ,$
306.020    ,$
306.121   ,$
306.221  ,$
306.322 ,$
306.422  ,$     
306.523   ,$   
306.624    ,$ 
306.724     ,$
306.824    ,$
306.925   ,$
307.018  ,$
307.118 ,$
307.219,$
307.319 ,$      
307.419  ,$    
307.520   ,$  
307.620    ,$
307.720    ,$
307.820   ,$
307.920  ,$
308.020 ,$
308.120  ,$    
308.220   ,$  
308.320    ,$
308.420     ,$ 
308.520      ,$
308.620       ,$
308.720       ,$
308.820       ,$
308.920      ,$
309.020       ,$
309.119      ,$
309.219       ,$
309.319       ,$
309.418       ,$
309.518       ,$
309.618       ,$
309.717       ,$
309.817       ,$
309.916      ,$
310.016       ,$
310.115       ,$
310.214       ,$
310.314       ,$
310.413       ,$
310.512       ,$
310.612       ,$
310.711       ,$
310.810       ,$
310.909       ,$
311.016       ,$
311.115       ,$
311.214       ,$
311.313       ,$
311.412      ,$
311.511       ,$
311.610      ,$
311.709     ,$
311.808    ,$
311.907   ,$
312.013  ,$
312.112 ,$
312.210,$
312.309 ,$     
312.408  ,$   
312.507   ,$ 
312.605    ,$
312.711   ,$
312.810    ,$  
312.908     ,$
313.007     ,$
313.105    ,$
313.204   ,$
313.309  ,$
313.408 ,$
313.506,$
313.605 ,$     
313.703  ,$   
313.801   ,$ 
313.907    ,$
314.005   ,$
314.103  ,$
314.201 ,$
314.307,$
314.405 ,$     
314.503  ,$    
314.601   ,$   
314.699    ,$ 
314.804     ,$
314.902     ,$
315.000    ,$
315.098   ,$
315.203  ,$
315.301 ,$
315.399,$
315.496 ,$     
315.601  ,$   
315.699   ,$ 
315.797    ,$
315.901   ,$
315.999  ,$
316.097 ,$
316.194,$
316.299 ,$     
316.396  ,$   
316.494   ,$ 
316.598    ,$
316.696     ,$ 
316.793      ,$
316.898     ,$
316.995    ,$
317.092   ,$
317.197  ,$
317.294 ,$
317.391,$
317.495 ,$     
317.593  ,$   
317.690   ,$ 
317.794    ,$
317.891   ,$
317.995  ,$
318.092 ,$
318.189,$
318.293 ,$     
318.390  ,$   
318.494   ,$ 
318.591    ,$
318.688   ,$
318.792 ,$
318.888  ,$
318.992   ,$  
319.089    ,$
319.186    ,$
319.289   ,$
319.386  ,$
319.490   ,$   
319.586    ,$ 
319.690     ,$
319.786    ,$
319.890   ,$
319.986]      
mchan=n_elements(chan_air)
print,mchan
print,chan_air

chan=chan_air

c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       gamma(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma(il) = gamma(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor



;	II. Write slit-averaged ETS to file:


close,3    & openw,3, 'Xsec_krotkov'+citype+cfwhm
;close,3    & openw,3, 'Xsec'+citype+cfwhm
;printf,3,'Effective  absorption coefficients [atm-cm-1]                   
;printf,3,'Slit function:',citype,'	FWHM=',cfwhm
;printf,3,'lambda(vac)  ',' ','	ETS'                                                                           
;printf,3,'     A       ',' 1/atm_cm  '
printf,3,mchan
	for il=0,mchan-1 do begin
	printf,3,1.*chan(il),c0v_c(il) , c1v_c(il), c2v_c(il)                                                                 
        format='(7e12.4)'
	endfor
close,3

close,3    & openw,3, 'F0_krotkov'+citype+cfwhm
printf,3,mchan
	for il=0,mchan-1 do begin
printf,3,1.*chan(il),solv_c(il)                                                                                       
       format='(7e12.4)'
	endfor
close,3


;                                       PLOT
if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='Brewer_'+slit+'.ps'
endelse


stop
end
