;w_air=[305.2000,311.7000,325.8000, 332.3000, 339.1, 378.8]   ;  UV-MFRSR582 radiative wavelengths
;   itype=0 & citype='_rectangular' & fwhm=2.0 & cfwhm='_fwhm2nm'
; 			Effective x-sections:                                      
;   itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm1.1'
;   itype=1 & citype='_triangular' & fwhm=0.45 & cfwhm='_fwhm045'
;   itype=0 & citype='_rectangular' & fwhm=4.0 & cfwhm='_fwhm4nm'
 w_air=[440.4] &  itype=0 & citype='_rectangular' & fwhm=10.0 & cfwhm='_fwhm10nm'
;    itype=0 & citype='_rectangular' & fwhm=5.0 & cfwhm='_fwhm5nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian


;	I. READ MONOCHOMATIC VACUUM x-sections: V217/coe.dat
;   	Monochromatic x-sections: Bass and Paur 
;		V8 extended beyong 410nm with V7 <700nm
mlt=2106 & mszat=0 &  read_coe, './BSBR_V8.DAT.extended',1,      mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;               V8
; mlt=1601 & mszat=0 &  read_coe, './BSBR_V8.DAT.ref',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;		V7
;mlt=1075 & mszat=0 &  read_coe, './BSBR_V7.DAT', 1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as: '../TOMRAD/v2.22/coe.dat.old', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 

;	Ib:  read SO2 abs coefficients
;read_so2,'gas2_sasha.coe',lv_tso2,gammav_tso2	; gammav_tso2 - SO2 abs coefficient [atm-cm-1]

;	Ic:  read NO2 abs coefficients
read_no2,'./no2vand2temp.all',23000,lv_tno2,no2_t220,no2_t294	; NO2 abs coefficient [atm-cm-1]

;ind_no2=where ( abs(lv_tno2-440.0) le 1.0,count)
;print,count
;print,'NO2 Wavelengths:' ,lv_tno2(ind_no2)
;print,'Gamma_NO2',no2_t294(ind_no2)

;	Ia read F0 at vac solar wavelengths
read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv


;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
gammav_s   = 	dblarr(ml_solv)
no2_s220      = 	dblarr(ml_solv)
no2_s294      = 	dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
;gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)*solv(*)

no2_s220(*)  = interpol(no2_t220,lv_tno2,l_solv)*solv(*)
no2_s294(*)  = interpol(no2_t294,lv_tno2,l_solv)*solv(*)
ind_no2=where ( abs(l_solv-440.0) le 1.0,count) &  print,'no2_s294',no2_s294(ind_no2)/solv(ind_no2)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)


;			CHANNEL WAVELENGTHS
;       actual air wavelengths [nm] of MFRSR #271 measured in 2002:
; w_air=[299.758,305.408,311.485,317.638,325.498,332.558,367.906]
;       schifted to vac  wavelengths [nm] of MFRSR #271 (see airvac.pro )
; w_vac=[299.845,305.497,311.575,317.730,325.592,332.654,368.011]
;chan_vac=[308.8,309.5,310.800,311.900,313.200,314.400,318.000,331.000]	; OMI wavelengths in vac
; chan_vac=[299.845,305.497,311.575,317.730,325.592,332.654,340.1,368.011,380.1]	; schifted to vac  wavelengths [nm] of MFRSR #271

;	AIR SSBUV Wavelengths: /omi/home/krotkov/ZUV/SSBUV_DATA/tab_ascii.pro
;the typical fwhm is 1.1nm and triangular shaped.  Wavelength bandcenters are located in the data files.   
;From: Matthew Kowalewski <mattk@ventus.gsfc.nasa.gov> 
;all wavelengths are in air since they are derived using lab test data.  
;the wavelength calibration is determined via lab measurements using various spectral line 
; lamps (e.g. Hg, Cd, Zn, Mg, etc) that produce singlet lines over the SSBUV wavelength range.  
; The line centers are then determined as a function of grating position and fit with the ebert equation (typical grating dispersion relation).  
; It's monitored approximately once a year if not more often.

; w_air=[300,305,311,317,325,332,340,380]                                         
; w_air=[340.0,388.0,400.0,450.,470.0]                                         
;w_air=[298.007,301.957,305.461,306.263,310.123,312.450,316.805,317.457,320.064,339.923,359.899,380.034,439.51128] 
;w_air=[298.007,301.957,305.461,306.263,310.123,312.450,316.805,317.457,320.064,339.923,359.899,380.034] 

airvac,w_air, chan_vac     ; shift to vac wavelengths

chan=chan_vac	& print,chan_vac


mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; Effective O3  abs coeff at -45C
gamma210T  = dblarr(mchan)	; Effective SO2 abs coeff
no2_c220  = dblarr(mchan)	; Effective NO2 abs coeff at channels
no2_c294  = dblarr(mchan)	; Effective NO2 abs coeff at channels

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
;      gamma210T(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)
       no2_c220(il) =slitavg(chan(il),  fwhm,   itype, l_solv, no2_s220)
       no2_c294(il) =slitavg(chan(il),  fwhm,   itype, l_solv, no2_s294)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
;       gamma210T(il) = gamma210T(il) / solv_c(il)
       no2_c220(il) = no2_c220(il) / solv_c(il)
       no2_c294(il) = no2_c294(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor


;	II. Write high resolution and chanel radiances to  files:


;close,3    & openw,3, 'coev_s'+citype+cfwhm
;printf,3,'Vac Wavelength  ',' c0v_s','c1v_s','	c2v_s','   betv_s','   rhov_s'
;ind=where(l_solv gt 290.0 and l_solv le 400.0 ,count)
;	for il=0,count-1 do begin
;	printf,3,l_solv(ind(il)),c0v_s(ind(il))/solv(ind(il)),c1v_s(ind(il))/solv(ind(il)),c2v_s(ind(il))/solv(ind(il)),betv_s(ind(il))/solv(ind(il)),rhov_s(ind(il))/solv(ind(il))
;	endfor

close,31  & openw,31,'no2_coe_eff'+citype+cfwhm
printf,31,'Effective  absorption coefficients [atm-cm-1]                   
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
printf,31,'lambda(vac)  ',' O3 (228K)','	betv','	rhov',' 	solv','   NO2_220','   NO2_294' 
printf,31,'     A       ',' 1/atm_cm      				1/atm'
	for il=0,mchan-1 do begin
 	printf,31,10.*chan(il),alpha228T(il),betv_c(il),rhov_c(il),solv_c(il),no2_c220(il),no2_c294(il),$
        format='(7e12.4)'
	endfor

close,3  & close, 31 


stop
end
