; 			Effective OMI BRD x-sections                                     
;The US Standard Atmosphere (1976) air temperatures for the 3 SO2 retrieval levels are:
TK=275.	& ch='_800mb'	;800 mb  2 km    275K
;TK=255.	& ch='_5km'	;540 mb  5 km    255K
;TK=217.	& ch='_15km'	;120 mb  15 km   217K

;    itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm110'	; TOMS slit
;    itype=3 & citype='_gaussian' & fwhm=0.38 & cfwhm='_fwhm038'	; OMI UV2 slit (Kai)
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;  FWHM=0.38nm

;   itype=1 & citype='_triangular' & fwhm=0.38 & cfwhm='_fwhm038'	; OMI UV2 slit 
;    itype=1 & citype='_triangular' & fwhm=0.45 & cfwhm='_fwhm045'	; OMI UV2 slit
   itype=0 & citype='_rectangular' & fwhm=0.38& cfwhm='_fwhm038nm'
;   itype=0 & citype='_rectangular' & fwhm=10.0 & cfwhm='_fwhm10nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian


;	I. READ MONOCHOMATIC VACUUM x-sections: V217/coe.dat
;   	Monochromatic x-sections: Bass and Paur 
;		V8 extended beyong 410nm with V7
;mlt=2106 & mszat=0 &  read_coe, './BSBR_V8.DAT.extended', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;               V8
 mlt=1601 & mszat=0 &  read_coe, './BSBR_V8.DAT.ref', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;		V7
;mlt=1075 & mszat=0 &  read_coe, './BSBR_V7.DAT', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as: '../TOMRAD/v2.22/coe.dat.old', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 

;	Ib:  read SO2 abs coefficients
;read_so2,'so2_sasha.coe',lv_tso2,gammav_tso2	; gammav_tso2 - SO2 abs coefficient [atm-cm-1]
read_so2,TK,lv_tso2,gammav_tso2    ; gammav_tso2 - SO2 abs coefficient [atm-cm-1] and T [K]



;	Ia read F0 at vac solar wavelengths
read_solar,'./mayer_vac_ipmmi.txt', 275, l_solv,ml_solv,solv

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)*solv(*)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)

;		!!!! check longer wavelength  !!!!
 ind=where(l_solv gt 300.0 and l_solv le 340.0 ,count)

;       actual air wavelengths [nm] of MFRSR #271 measured in 2002:
; w_air=[299.758,305.408,311.485,317.638,325.498,332.558,367.906]
;       schifted to vac  wavelengths [nm] of MFRSR #271 (see airvac.pro )
; w_vac=[299.845,305.497,311.575,317.730,325.592,332.654,368.011]

;chan_vac=l_solv(ind)   ;                                     SUSIM wavelengths in vac
;chan_vac=[308.65,312.56,317.57,322.37,331.29,360.40]		; EP/TOMS wavelengths in vac
;chan_vac=[308.70,312.61,317.62,322.42,331.34,360.15]		; OMI OMTO3 wavelengths in vac
;Nick,
;        Would you compute the absorption coefficients for the other OMI  
;wavelengths 310.8, 311.85, 313.20, and 314.40?  Then we will see how  
;this works with "good" wavelengths.

chan_vac=[308.7,309.7,310.800,311.850,312.61,313.200,314.400,317.62,322.42,331.34,345.4]	; OMI wavelengths in vac

;chan_vac=[307.20000,       307.50000,       307.80000 ,      308.10000 ,      308.40000,       308.70000,       309.00000,       309.30000,       309.60000,       309.90000,       310.20000,       310.3500,$
;       310.50000   ,    310.65000   ,    310.80000    ,   310.95000    ,   311.10000   ,    311.25000   ,    311.40000   ,    311.55000   ,    311.70000   ,    311.85000   ,    312.00000   ,    312.15000,$
;       312.30000   ,    312.45000   ,    312.60000    ,   312.75000    ,   312.90000   ,    313.05000   ,    313.20000   ,    313.35000   ,    313.50000   ,    313.65000   ,    313.80000   ,    313.95000,$
;       314.10000   ,    314.25000   ,    314.40000    ,   314.55000    ,   314.70000   ,    314.85000   ,    315.00000   ,    315.15000   ,    315.30000   ,    315.45000   ,    315.60000   ,    315.75000,$
;       315.90000   ,    316.05000   ,    316.20000    ,   316.35000    ,   316.50000   ,    316.65000   ,    316.80000   ,    316.95000   ,    317.10000   ,    317.25000   ,    317.40000   ,    317.55000,$
;       317.70000   ,    317.85000   ,    318.00000    ,   318.15000    ,   318.30000   ,    318.45000   ,    318.60000   ,    318.75000   ,    318.90000   ,    319.05000   ,    319.20000   ,    319.35000,$
;       319.50000   ,    319.65000   ,    319.80000    ,   319.95000    ,   320.10000   ,    320.25000   ,    320.40000   ,    320.55000   ,    320.70000   ,    320.85000   ,    321.00000   ,    321.15000,$
;       321.30000   ,    321.45000   ,    321.60000    ,   321.75000    ,   321.90000   ,    322.05000   ,    322.20000   ,    322.35000   ,    322.50000   ,    322.65000   ,    322.80000   ,    322.95000,$
;       323.10000   ,    323.25000   ,    323.40000    ,   323.55000]


chan=chan_vac	& print,chan_vac

mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma210T  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       gamma210T(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma210T(il) = gamma210T(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor


;	II. Write high resolution and chanel radiances to  files:


;close,3    & openw,3, 'coev_s'
;printf,3,'Vac Wavelength  ',' alpha228T','   gamma210T ', '	gamma210T/alpha228T'
;
;	for il=0,count-1 do begin
;;	printf,3,l_solv(ind(il)),c0v_s(ind(il))/solv(ind(il)),c1v_s(ind(il))/solv(ind(il)),c2v_s(ind(il))/solv(ind(il)),betv_s(ind(il))/solv(ind(il)),rhov_s(ind(il))/solv(ind(il)),gammav_s(ind(il))/solv(ind(il))
;	printf,3,l_solv(ind(il)),alpha228T_s(ind(il))/solv(ind(il)),gammav_s(ind(il))/solv(ind(il)),gammav_s(ind(il))/alpha228T_s(ind(il))
;	endfor

close,31  & openw,31,'so2_coe_eff'+citype+cfwhm+ch
printf,31,'Effective  absorption coefficients [atm-cm-1]                   
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
;printf,31,'lambda(vac)  ',' oz0','   	oz1','		oz2','   		Rayleigh','   	Depol','	ETS'
printf,31,'lambda(vac)  ',' O3 (228K)','	SO2','  	SO2/O3',' Ap',	'	GammaP','	Gammap/AlphaP' 
printf,31,'     A       ',' 1/atm_cm           	1/atm         		'
	for il=0,mchan-1 do begin
	printf,31,10.*chan(il),alpha228T(il) , gamma210T(il),gamma210T(il)/alpha228T(il)
;	printf,31,10.*chan(il),alpha228T(il) , gamma210T(il),gamma210T(il)/alpha228T(il),alpha228T(il)-alpha228T(il+1),gamma210T(il)-gamma210T(il+1),$
;        (gamma210T(il)-gamma210T(il+1))/(alpha228T(il)-alpha228T(il+1)),$
;	printf,31,10.*chan(il),c0v_c(il),c1v_c(il),c2v_c(il),betv_c(il),rhov_c(il),solv_c(il),$
        format='(7e12.4)'
	endfor

close,3  & close, 31 


stop
end
