mode='screen'
mode='print'

yn=0.4 & yx=1.1

if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8 & window, retain=2
endif else begin
set_plot,'PS' & device,/color,/landscape,filename='ratio_susim_chance'+'.ps'
endelse


;set_plot,'PS' &  device,filename='r_susim_chance.ps',/color,/landscape
;set_plot,'x' & window, retain=2


;               Blue                    Red
;       -30 -25 -20 -15 -10 -5      0  +5  +10 +15 +20 +25 +30 +35
;      0   1   2   3   4   5   6   7   8   9   10  11  12  13  14
rr = [255,000,000,000,000,100,150,200,255,255,255,255,200,150,000]
gg = [255,000,050,100,150,200,220,240,230,150,100,060,020,000,000]
bb = [255,150,240,255,255,255,255,255,230,150,100,060,020,000,000]
color1=9 &  color2=2 

tvlct,rr,gg,bb
!p.background=0

;	Read smoothed solar flux 
sol_min=302 & sol_max=323
;	A. read Mayer's solar flux in vac,
mayer: 
read_solar,'./F0_susim_triangular_fwhm060',   1.0,275,1,201,sol_wave1,ml_solv1,sol_irrad1 & print,sol_wave1
;	B. read K Chance solar flux in vac 
chance: 
read_solar,'./F0_kchance_triangular_fwhm060', 1.0,275,1,201,sol_wave2,ml_solv2,sol_irrad2 & print,sol_wave2

;	C.  Ratio interpolations to K Chance wavelength scale: sol_wave2
sol_irrad1_w2 =interpol(sol_irrad1,sol_wave1,sol_wave2)
r=sol_irrad2/sol_irrad1_w2

;		PLOT

!x.thick=3 & !y.thick=3
!p.charsize=1.2
!p.thick=3


; 		PLOT ratio: CHANCE / SSBUV   at FWHM=0.6nm                   
plot,sol_wave2, r              ,thick=3.00,/nodata,color=14,$
xtitle='Wavelength, nm',xrange=[sol_min-2,sol_max+2],xstyle=1,$
title='SUSIM  versus K. Chance at Brewer resoltion (FWHM=0.6nm) ',$
ytitle='CHANCE/SUSIM',yrange=[yn,yx],ystyle=1

oplot,sol_wave1,sol_irrad1,thick=1.0,color=12	 & xyouts,320,0.8,'SUSIM',color=12		; SUSIM 
oplot,sol_wave2,sol_irrad2,thick=1.0,color=2	 & xyouts,320,0.7,'CHANCE',color=2 	; Chance

oplot,sol_wave2,sol_irrad2/sol_irrad1_w2,thick=1.0,color=14     
plots,[sol_min-2,sol_max+2],[1.,1.],thick=0.5,color=14
xyouts,325,1.5,'CHANCE/SUSIM'
bw=[303.31071,306.39797,310.16459,313.60397,316.90951,320.08698]
for i=0,5 do plots,[bw(i),bw(i)],[yn,yx],color=14





if mode eq 'print' then device,/close
stop
end
