pro get_xsec,SO2_TEMP,itype,citype,fwhm,cfwhm,chan_vac,	alpha228T,gamma,betv_c,rhov_c

; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian

input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE


;	Ib:  read SO2 abs coefficients
read_so2,'./SO2/bogumil2000_'+SO2_TEMP,'SCIA_xsection',2,1402,35,SO2_TEMP,'nm',lv_tso2,gammav_tso2


input_solar_choice:	;	Ia read F0 at vac solar wavelengths
solar_name='' &  read,'Input solar flux choice ''mayer''  or ''chance'': ',solar_name

CASE solar_name OF
;       Ia read F0 at vac solar wavelengths
'mayer' : read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv
'chance': read_solar,'./ETS/kchance_295_325.txt',  1.0, 275,1, 3001,l_solv,ml_solv,solv
ELSE:  begin & print,'not a valid name' & goto,input_solar_choice & end
ENDCASE &  print,'min_wav=',l_solv[0],'	max_wav=',l_solv[ml_solv-1]

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)*solv(*)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)

;		!!!! check longer wavelength  !!!!
 ind=where(l_solv gt 300.0 and l_solv le 340.0 ,count)
print,'Input Solar data:	', solar_name 
print,'Solar wavelengths between 300.0 and 340.0',l_solv(ind)


;chan_vac=[308.7000, 310.8000, 311.8500, 312.6100, 313.2000,314.4000,317.6200,322.4200, 331.3400, 345.4000, 360.1500]
chan=chan_vac	& print,chan_vac

mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       gamma(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma(il) = gamma(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor

return
end


;	I. calculate cross-sections

SO2_TEMP='223'	;  explicit temperatures for SCIA SO2 cross-sections [Bogumil et al 2001]
;    itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm110'	; TOMS slit
     itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167

wavelengths_vac=[308.7000, 310.8000, 311.8500, 312.6100, 313.2000,314.4000,317.6200,322.4200, 331.3400, 345.4000, 360.1500] & mchan=n_elements(wavelengths_vac)
get_xsec,SO2_TEMP,itype,citype,fwhm,cfwhm,wavelengths_vac, alpha228T,gamma,betv_c,rhov_c

;	II. Write high resolution and chanel radiances to  files:


read_so2,'./SCIAMACHY_PFM_SO2_Absorption_TCelsius_FWHM38_coef.txt','temp_coeff',4,571,11,SO2_TEMP,'nm',lv_tso2,gammav_tso2
gamma_old= dblarr(mchan) & gamma_old=interpol(gammav_tso2,lv_tso2,wavelengths_vac)

close,31  & openw,31,'omi_so2_coe_eff'+citype+cfwhm
printf,31,'Effective  absorption coefficients [atm-cm-1]                   
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
printf,31,'lambda(vac)  ',' O3 (228K)','		SO2('+SO2_TEMP+')	SO2_old('+SO2_TEMP+')		Error,%'
printf,31,'     A       ',' 1/atm_cm           		1/atm         		'
	for il=0,mchan-1 do begin
	printf,31,10.*wavelengths_vac(il),alpha228T(il) , gamma(il),gamma_old(il), 200.*(gamma(il)-gamma_old(il))/(gamma_old(il)+gamma(il))
        format='(7e12.4)'
	endfor

close,3  & close, 31 


stop
end
