;SO2_TEMP='293'
SO2_TEMP='273'
;SO2_TEMP='243'
;SO2_TEMP='223'
;SO2_TEMP='203'

chan_vac=[440.4] &  itype=0 & citype='_rectangular'& fwhm=10.00 & cfwhm='_fwhm100'	; MFRSR582 
;chan_vac=[305.2000,311.7000,325.8000, 332.3000, 339.1, 378.8] &  itype=0 & citype='_rectangular'& fwhm=2.00 & cfwhm='_fwhm200'	; MFRSR582 
;    itype=1 & citype='_triangular' & fwhm=1.00 & cfwhm='_fwhm100'	; OMPS-NM slit 
;    itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm110'	; TOMS slit
;    itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian

input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;mszat=0 &  read_coe, '/BSBR_V8.DAT.ref',1, 1601,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ; V8
;       same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;read_coe, './BSBR_V7.DAT',1, 1075,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ;       V7
;       same as: '../TOMRAD/v2.22/coe.dat.old',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE


;	Ib:  read SO2 abs coefficients
read_so2,'./SO2/bogumil2000_'+SO2_TEMP,'SCIA_xsection',2,1402,35,SO2_TEMP,'nm',lv_tso2,gammav_tso2


input_solar_choice:	;	Ia read F0 at vac solar wavelengths
solar_name='' &  read,'Input solar flux choice ''mayer''  or ''chance'': ',solar_name

CASE solar_name OF
;       Ia read F0 at vac solar wavelengths
'mayer' : read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv
'chance': read_solar,'./ETS/kchance_295_325.txt',  1.0, 275,1, 3001,l_solv,ml_solv,solv
ELSE:  begin & print,'not a valid name' & goto,input_solar_choice & end
ENDCASE &  print,'min_wav=',l_solv[0],'	max_wav=',l_solv[ml_solv-1]

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)*solv(*)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)

;		!!!! check longer wavelength  !!!!
 ind=where(l_solv gt 300.0 and l_solv le 340.0 ,count)

;Date: Fri, 25 Aug 2006 14:18:53 -0400 
;From: "Kai Yang" <Kai.Yang.1@gsfc.nasa.gov> 
;Subject: SO2 and O3 absorption coefficients. 
;OMTO3 wavelengths in nm
;308.7000, 310.8000, 311.8500, 312.6100, 313.2000, 314.4000, 317.6200,
;322.4200, 331.3400, 345.4000, 360.1500
;
;T = 275.0 K
;SO2 absorption coefficients
;12.53057, 8.521686, 3.377695, 3.921860, 6.011054, 2.396039,  2.061739,
;0.6653548, 3.3675179E-02, 0, 0
;O3 absorption coefficients
;3.220181, 2.366921, 2.101296, 1.796670, 1.690511, 1.430708, 1.009748,
;0.5623671, 0.1873601, 1.3157430E-02, 1.7212256E-03
;
;T= 255.0 K
;SO2 absorption coefficients
;12.81153, 8.747684, 3.272650, 3.883037,  6.083823, 2.332526, 2.014785,
;0.6436025       2.7297143E-02, 0, 0
;O3 absorption coefficients
;3.072163, 2.247575, 1.991443, 1.686476, 1.590417, 1.333591,
;0.9524673, 0.5285356, 0.1748579, 1.0175146E-02, 1.4083113E-03
;
;T = 217.0 K
;SO2 absorption coefficients
;13.54684, 8.990827, 3.058346, 3.740465, 6.145513, 2.184574, 1.902008,
;0.6133506       2.6209600E-02, 0, 0
;O3 absorption coefficients
;2.941389, 2.123735, 1.867288, 1.559609, 1.487170, 1.218828,
;0.9024094, 0.4962375, 0.1617340, 7.3023788E-03, 1.0738388E-03
;Kai

;________________________________________
;From: Simon Carn [scarn@mtu.edu]
;Sent: Tuesday, May 29, 2012 10:51 AM
;To: Colin Seftor
;Cc: Krotkov, Nickolay A. (GSFC-6140); Arlin Krueger; Kai Yang
;Subject: Re: new SO2 absorption coefficients for OMPS RE: Congrats  RE: First detection of SO2 using OMPS
;;
;I am currently using the files from /omps/live/dd/60000/TC_EDR_TO3/ on the OMI TLCF.
;Simon
;
;On May 29, 2012, at 9:40 AM, Colin Seftor wrote:
;Nick and Simon,
;I'm not sure which product Simon is using, the operational one from NOAA or the PEATE one.
;The PEATE product provides the same 12 wavelengths, at the same band-centered values, as OMI:
;308.7
;310.8
;311.85
;312.61
;313.2
;314.4
;317.62
;322.42
;331.34
;345.4
;360.15
;372.8
;These values can also be found under the CALIBRATION_DATA group. 
;The bandpass for each of the wavelengths is about 1.0 nm FWHM, not 1.1 nm 
;(the bandpass for the nadir profiler wavelengths is 1.1 nm).  
;The bandpass shape, and width, changes slightly from one end of the CCD to the other, i
;but the effect is rather minor, at least in total ozone i
;(the changes results in a 0.5% change, maybe slightly larger, in total column ozone from one side to the other).
;Colin Seftor, PhD
;NASA NPP Science Team&   Ozone PEATE
;Science Systems and Applications, Inc
;301.867.2027
;colin.seftor@ssaihq.com<mailto:colin.seftor@ssaihq.com>
;

chan=chan_vac	& print,chan_vac

mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       gamma(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma(il) = gamma(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor



; OMI  SO2 abs coeffcientse
read_so2,'./SCIAMACHY_PFM_SO2_Absorption_TCelsius_FWHM38_coef.txt','temp_coeff',4,571,11,SO2_TEMP,'nm',lv_tso2,gammav_tso2
gamma_old= dblarr(mchan) & gamma_old=interpol(gammav_tso2,lv_tso2,chan)

close,31  & openw,31,'mfrsr_coe_eff'+citype+cfwhm+'_TSO2'+SO2_TEMP
printf,31,'Effective  absorption coefficients [atm-cm-1]                   
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
printf,31,'lambda(vac)  ',' c0v_c(il),c1v_c(il),c2v_c(il) ' , ' O3 (228K)','  SO2(273)'        
printf,31,'     A       ',' 1/atm_cm           		1/atm         		'
	for il=0,mchan-1 do begin
	printf,31,10.*chan(il),c0v_c(il),c1v_c(il),c2v_c(il),alpha228T(il) , gamma(il)                                           
        format='(7e12.4)'
	endfor

close,3  & close, 31 


stop
end
