; ozone_test.pro

;Hi Gordon,
;Yours are scaled X-sections [cm^2/molecule], not abs. coefficients in my file (i.e. alphas, see attached plot)
;The conversion factor from alpha to scaled X-section is:
; X-section = 10/2.688*alpha

;Here they are:

;Bass and Paur X-section: 1.d-20*(c0+TC*c1 + TC*TC*c2),   TC=-40.0
;        320.000      2.83622
;        320.100      2.80981
;        320.200      2.58582
;        320.300      2.33863
;        320.400      2.15061
;        320.500      1.99340
;        320.600      1.97895
;        320.700      1.85397
;        320.800      1.68332
;        320.900      1.57414
;        321.000      1.44304
;        321.100      1.37176
;        321.200      1.35470
;
;Daumont X-section: 1.d-20*(c0+TC*c1 + TC*TC*c2), TC=-40.0
;        320.003      2.71970
;        320.013      2.75567
;        320.023      2.78455
;        320.033      2.80629
;        320.043      2.82259
;        320.053      2.83473
;        320.063      2.84305
;        320.073      2.84784
;        320.083      2.84997
;        320.093      2.84867
;        320.103      2.84384
;        320.113      2.83357
;        320.123      2.82079
;        320.133      2.80474
;        320.143      2.78714
;        320.153      2.76842
;        320.163      2.74972
;        320.173      2.72975


;NOT Alphas at -40 degrees C  (agrees with Dumont) -G
;Bass & Paur X-sections calcualted at -40C
;
;      319.999      2.82503
;      320.049      2.74638
;      320.099      2.60733
;      320.149      2.47901
;      320.199      2.35676
;      320.249      2.26098
;      320.299      2.16680
;      320.349      2.07071
;      320.399      1.99502
;      320.450      1.98991
;      320.500      1.98642
;      320.550      1.93937
;      320.600      1.86762
;      320.650      1.77517
;      320.700      1.69036
;      320.750      1.64954
;      320.800      1.58761
;      320.850      1.50555
;      320.900      1.44988
;      320.950      1.40969
;      321.000      1.37396
;      321.048      1.36359
;      321.100      1.35509
;      321.149      1.35576
;      321.199      1.37283
;      321.249      1.38482

xmin=307.5 & xmax=308.5 & ymin=10 & ymax=100
;xmin=317. & xmax=335 &  ymin=1.3 & ymax=10

SO2_TEMP='223'
O3_TEMP='233' & oz_temp_c=-40.0

;    itype=1 & citype='_triangular' & fwhm=1.00 & cfwhm='_fwhm100'	; alex's slit FWHM=1.0nm
     itype=1 & citype='_triangular' & fwhm=0.55 & cfwhm='_fwhm060'	; UV program default
;    itype=1 & citype='_triangular' & fwhm=0.60 & cfwhm='_fwhm060'	; Brewer slit
;    itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm110'	; TOMS slit
;    itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian

input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

;ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
ozone_name='bass'
;ozone_name='daumont'
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;mszat=0 &  read_coe, '/BSBR_V8.DAT.ref',1, 1601,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ; V8
;       same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;read_coe, './BSBR_V7.DAT',1, 1075,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ;       V7
;       same as: '../TOMRAD/v2.22/coe.dat.old',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE

;			PLOT
mode='screen' 
;mode='print'   & name_output='Ozone_Alpha_plot.ps'

if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
endif else begin
set_plot,'PS' & device,/color,/landscape,filename=name_output
endelse


ctitle='ozone Alpha at temperature='+string(oz_temp_c,format='(f5.1)')
title_plot


!p.color=14

plot,lv_t,c0v_t,/nodata,$
;plot_io,lv_t,c0v_t,/nodata,$
title=ctitle,$
xr=[xmin,xmax],/xs,xtitle='Wavelength, nm',$
;yr=[ymin,ymax],/ys,ytitle='Gaseous absorption coefficient, atmcm-1'
ytitle='Gaseous absorption coefficient, atmcm-1'



!p.color=11		;Ia :  Bass and Paur ozone abs coefficients 
oplot,lv_t,c0v_t+c1v_t*oz_temp_c+c2v_t*oz_temp_c*oz_temp_c, psym=1
xyouts,320,0.9,'Bass and Paur',charsize=2

scale=10.0/2.688	;  10^-20 [cm2/molecule]
ig=where (lv_t ge 319.999 and lv_t le 321.249,count)
print,'Bass and Paur X-section: 1.d-20*(c0+TC*c1 + TC*TC*c2,	TC='+string(oz_temp_c,format='(f5.1)')
for i=0,count-1 do print,lv_t(ig(i)),scale*(c0v_t(ig(i))+c1v_t(ig(i))*oz_temp_c+c2v_t(ig(i))*oz_temp_c*oz_temp_c),format='(f15.3,f13.5)'
print

!p.color=3 		;       Ib:  Daumont  ozone abs coefficients
read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ig=where (lv_t ge 319.999 and lv_t le 321.249,count)

xyouts,320,1.1 ,'Daumont',charsize=2

oplot,lv_t,c0v_t+c1v_t*oz_temp_c+c2v_t*oz_temp_c*oz_temp_c, line=1
print,'Daumont X-section: 1.d-20*(c0+TC*c1 + TC*TC*c2'+string(oz_temp_c,format='(f5.1)')
for i=0,count-1 do print,lv_t(ig(i)),scale*(c0v_t(ig(i))+c1v_t(ig(i))*oz_temp_c+c2v_t(ig(i))*oz_temp_c*oz_temp_c),format='(f15.3,f13.5)'


if mode ne 'screen' then device,/close
;

stop
end
