; 			Effective x-sections:                                      
   itype=0 & citype='_rectangular' & fwhm=2.0 & cfwhm='_fwhm2nm'
;   itype=0 & citype='_rectangular' & fwhm=10.0 & cfwhm='_fwhm10nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian

set_plot,'PS' & device,/landscape,filename='efective_coe'+citype+cfwhm+'.ps',/color
xmin=295. & xmax=380. & ymin=0.01 & ymax=10.
;xmin=300. & xmax=450. & ymin=0.01 & ymax=5.

;               Blue                    Red
;        0   1    2   3   4  5  6    7   8   9   10  11  12  13  14
;       -30 -25 -20 -15 -10 -5      0  +5  +10 +15 +20 +25 +30 +35
rr = [255,000,000,000,000,100,150,000,255,255,255,255,200,150,000]
gg = [255,000,050,100,150,200,220,240,230,150,100,060,020,000,000]
bb = [255,150,240,255,255,255,255,000,230,150,100,060,020,000,000]
col=[0,2,9,11,13,14]

tvlct,rr,gg,bb & !p.background=14
!p.thick=4
!p.charsize=1.4
!p.charthick=4
!x.thick=5
!y.thick=5


;	I. READ MONOCHOMATIC VACUUM x-sections: V217/coe.dat
;   	Monochromatic x-sections: Bass and Paur 
;		V8 extended beyong 410nm with V7
mlt=2106 & mszat=0 &  read_coe, './BSBR_V8.DAT.extended', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;               V8
;mlt=1601 & mszat=0 &  read_coe, '/BSBR_V8.DAT.ref', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;		V7
;mlt=1075 & mszat=0 &  read_coe, './BSBR_V7.DAT', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 
;	same as: '../TOMRAD/v2.22/coe.dat.old', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header 

;	Ia read F0 at vac solar wavelengths
read_solar,'./mayer_vac_ipmmi.txt', 275, l_solv,ml_solv,solv


;       PLOT
plot_io,l_solv,solv,line=1,/nodata,color=14,$
title='UV-MFRSR #271: effective molecular cross-sections and ETS',$
xrange=[xmin,xmax],/xstyle,xtitle='Wavelength, nm',$
yrange=[ymin,ymax],/ystyle,ytitle=''
!p.color=8
oplot,l_solv,solv
oplot,lv_t,betv_t
TC=-45	; T in degrees Celciums
oplot,lv_t,(c0v_t+TC*c1v_t+TC*TC*c2v_t)


;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
c0v_s      = dblarr(ml_solv)
c1v_s      = dblarr(ml_solv)
c2v_s      = dblarr(ml_solv)
betv_s     = dblarr(ml_solv)
rhov_s     = dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)

!p.color=4
oplot,l_solv,betv_s/solv
!p.color=1
;oplot,l_solv,c0v_s/solv 
oplot,l_solv,(c0v_s+TC*c1v_s+TC*TC*c2v_s)/solv


;	UV-MFRSR #271 air wavelengths: 
w_air=[299.758,305.408,311.485,317.638,325.498,332.558,367.906]
airvac,w_air, chan_vac     ; shift to vac wavelengths

chan=chan_vac	& print,chan_vac

mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor

!p.color=11
oplot,chan_vac,betv_c,psym=2
oplot,chan_vac,solv_c,psym=2
oplot,chan_vac,(c0v_c+TC*c1v_c+TC*TC*c2v_c),psym=2

device,/close
stop

;	II. Write high resolution and chanel radiances to  files:


close,3    & openw,3, 'coev_s'+citype+cfwhm
printf,3,'X-sections interpolated to SUSIM ETS flux vac  wavelengths'                
printf,3,'Vac Wavelength  ',' c0v_s','c1v_s','	c2v_s','   betv_s','   rhov_s'
ind=where(l_solv gt 290.0 and l_solv le 400.0 ,count)
	for il=0,count-1 do begin
	printf,3,l_solv(ind(il)),c0v_s(ind(il))/solv(ind(il)),c1v_s(ind(il))/solv(ind(il)),c2v_s(ind(il))/solv(ind(il)),betv_s(ind(il))/solv(ind(il)),rhov_s(ind(il))/solv(ind(il))
	endfor

close,31  & openw,31,'coe_eff'+citype+cfwhm
printf,31,'Effective X-sections'                    
printf,31,'Slit function:',citype,'	FWHM=',cfwhm
printf,31,'lambda(vac)  ',' oz0','   	oz1','		oz2','   		Rayleigh','   	Depol','	ETS'
printf,31,'     A       ',' 1/atm_cm                     	1/atm         		[W/ (m2 nm)]'
	for il=0,mchan-1 do begin
	printf,31,10.*chan(il),c0v_c(il),c1v_c(il),c2v_c(il),betv_c(il),rhov_c(il),solv_c(il),$
        format='(7e12.4)'
	endfor

close,3  & close, 31 


stop
end

