SO2_TEMP='223'
O3_TEMP='227' & oz_temp_c=-45.0

     itype=1 & citype='_triangular' & fwhm=1.00 & cfwhm='_fwhm100'	; alex's slit FWHM=1.0nm
;    itype=1 & citype='_triangular' & fwhm=0.60 & cfwhm='_fwhm060'	; Brewer slit
;    itype=1 & citype='_triangular' & fwhm=1.10 & cfwhm='_fwhm110'	; TOMS slit
;    itype=3 & citype='_gaussian' & fwhm=0.3167 & cfwhm='_fwhm03167'	; this parameter used with the new slitavg.pro
;    itype=3 & citype='_gaussian' & fwhm=0.134766 & cfwhm='_fwhm03167'	; this parameter used with the old slitavg.old:  a2=fwhm/2/sqrt(2ln(2) , fwhm=0.3167
; slit(x,FWHM)=exp(-4ln2 x^2/(FWHM)^2 )/sqrt(pi*(FWHM)^2/4ln2 )
;   itype=0 & citype='_rectangular' & fwhm=0.3167 & cfwhm='_fwhm03167nm'
; 0- rectangular; 1-triangular; 2 -LORE; 3- general Gaussian

input_ozone_choice:              ;      Ia. READ MONOCHOMATIC VACUUM x-sections

;ozone_name='' &  read,'Input ozone cross-section choice ''bass''  or ''daumont'': ',ozone_name
ozone_name='daumont'
CASE ozone_name OF
;       Monochromatic x-sections: Daumont and Breon: 270-500nm
'daumont':  read_coe, '/misc/userdirs/krotkov/RT/XEFF/OMSAO_O3_Brion_TCelsius_coef.txt',10,22996,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;       Monochromatic x-sections: Bass and Paur V8 extended beyong 410nm with V7
'bass':     read_coe, './BSBR_V8.DAT.extended',1, 2106,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;mszat=0 &  read_coe, '/BSBR_V8.DAT.ref',1, 1601,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ; V8
;       same as  '../TOMRAD/v2.22/coe.dat', mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
;read_coe, './BSBR_V7.DAT',1, 1075,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header ;       V7
;       same as: '../TOMRAD/v2.22/coe.dat.old',1, mlt,lv_t, c0v_t,c1v_t,c2v_t,betv_t,rhov_t,header
ELSE:  begin & print,'not a valid name' & goto,input_ozone_choice & end
ENDCASE

;			PLOT
mode='screen' 
mode='print'   & name_output='SBUV_gaseous_abs.ps'

ctitle='SBUV gaseous spectral absorption'
sbuv_wav=[301.9,305.8,312.5,317.5,331.2] & n_sbuv=n_elements(sbuv_wav)
xr=[300.,320.]
yr=[3.E-01,3.5E+1]

if mode eq 'screen' then begin
set_plot,'X' & device,pseudo_color=8
title_plot_screen
endif else begin
set_plot,'PS' & device,/color,/landscape,filename=name_output
title_plot_ps
endelse


!p.color=14

plot_io,lv_t,c0v_t,/nodata,$
title=ctitle,$
xr=xr,/xs,xtitle='Wavelength, nm',$
yr=yr,/ys,ytitle='Gaseous absorption coefficient, atmcm-1'



!p.color=14 		;	Ib:  read SO2 abs coefficients
read_so2,'./SO2/bogumil2000_'+SO2_TEMP,'SCIA_xsection',2,1402,35,SO2_TEMP,'nm',lv_tso2,gammav_tso2
oplot,lv_tso2,gammav_tso2, line=0
xyouts,308,yr(1)/2,'SO!d2!n at '+SO2_TEMP+'K   FWHM ~0.2nm',charsize=2

!p.color=11		;Ia :  ozone abs coefficients 
alpha=c0v_t+c1v_t*oz_temp_c+c2v_t*oz_temp_c*oz_temp_c
oplot,lv_t,alpha, line=0
xyouts,313,yr(0)*2.0,'O!d3!n at '+O3_TEMP+'K ',charsize=2

!p.color=3 		;     Interpolate O3 to SO2 wavelengths and plot ratio
for i=0,n_sbuv-1 do plots,[sbuv_wav(i),sbuv_wav(i)],yr,thick=2
oplot,lv_tso2,gammav_tso2/interpol(alpha,lv_t,lv_tso2), line=0


if mode ne 'screen' then device,/close
;

stop



;	Ia read F0 at vac solar wavelengths
read_solar,'./ETS/mayer_vac_ipmmi.txt', 0.001,275,14,8479,l_solv,ml_solv,solv
;read_solar,   './mayer_vac_ipmmi.txt',       275,        l_solv,ml_solv,solv

;       Extrapolate x-sections to the solar vac wavelengths: ltv --> l_solv
;				multiply with ETS
c0v_s      = 	dblarr(ml_solv)
c1v_s      = 	dblarr(ml_solv)
c2v_s      = 	dblarr(ml_solv)
alpha228T_s   = dblarr(ml_solv)
gammav_s      = dblarr(ml_solv)
betv_s     = 	dblarr(ml_solv)
rhov_s     = 	dblarr(ml_solv)

c0v_s(*)  = interpol(c0v_t,lv_t,l_solv)*solv(*)
c1v_s(*)  = interpol(c1v_t,lv_t,l_solv)*solv(*)
c2v_s(*)  = interpol(c2v_t,lv_t,l_solv)*solv(*)
alpha228T_s(*) = c0v_s(*) + c1v_s(*)*(-45.0) + c2v_s(*)*2025.0 
gammav_s(*)  = interpol(gammav_tso2,lv_tso2,l_solv)*solv(*)
betv_s(*) = interpol(betv_t,lv_t,l_solv)*solv(*)
rhov_s(*) = interpol(rhov_t,lv_t,l_solv)*solv(*)

;		!!!! check longer wavelength  !!!!
 ind=where(l_solv gt 300.0 and l_solv le 340.0 ,count)

;Date: Fri, 25 Aug 2006 14:18:53 -0400 
;From: "Kai Yang" <Kai.Yang.1@gsfc.nasa.gov> 
;Subject: SO2 and O3 absorption coefficients. 
;OMTO3 wavelengths in nm
;308.7000, 310.8000, 311.8500, 312.6100, 313.2000, 314.4000, 317.6200,
;322.4200, 331.3400, 345.4000, 360.1500
;
;T = 275.0 K
;SO2 absorption coefficients
;12.53057, 8.521686, 3.377695, 3.921860, 6.011054, 2.396039,  2.061739,
;0.6653548, 3.3675179E-02, 0, 0
;O3 absorption coefficients
;3.220181, 2.366921, 2.101296, 1.796670, 1.690511, 1.430708, 1.009748,
;0.5623671, 0.1873601, 1.3157430E-02, 1.7212256E-03
;
;T= 255.0 K
;SO2 absorption coefficients
;12.81153, 8.747684, 3.272650, 3.883037,  6.083823, 2.332526, 2.014785,
;0.6436025       2.7297143E-02, 0, 0
;O3 absorption coefficients
;3.072163, 2.247575, 1.991443, 1.686476, 1.590417, 1.333591,
;0.9524673, 0.5285356, 0.1748579, 1.0175146E-02, 1.4083113E-03
;
;T = 217.0 K
;SO2 absorption coefficients
;13.54684, 8.990827, 3.058346, 3.740465, 6.145513, 2.184574, 1.902008,
;0.6133506       2.6209600E-02, 0, 0
;O3 absorption coefficients
;2.941389, 2.123735, 1.867288, 1.559609, 1.487170, 1.218828,
;0.9024094, 0.4962375, 0.1617340, 7.3023788E-03, 1.0738388E-03
;Kai

;chan_vac=[308.7000, 310.8000, 311.8500, 312.6100, 313.2000,314.4000,317.6200,322.4200, 331.3400, 345.4000, 360.1500]
;!wavelength[nm] irradiance[mW/m2/nm]  2sigma-noise[mW/m2/nm]    UT-time[hh] 
chan_vac=[ 335.100,$ 
335.600  ,$
336.100 ,$
336.600,$
337.100 ,$    
337.600  ,$  
338.100    ,$
338.600   ,$
339.100,$ 
339.600 ,$
340.100,$
340.600 ,$     
341.100  ,$   
341.600   ,$ 
342.100    ,$
342.600   ,$
343.100  ,$
343.600 ,$
344.100  ,$    
344.600   ,$  
345.100    ] 


chan=chan_vac	& print,chan_vac

mchan=n_elements(chan)
c0v_c      = dblarr(mchan)
c1v_c      = dblarr(mchan)
c2v_c      = dblarr(mchan)
alpha228T  = dblarr(mchan)	; O3  abs coeff at -45C
gamma  = dblarr(mchan)	; SO2 abs coeff

betv_c     = dblarr(mchan)
rhov_c     = dblarr(mchan)
solv_c     = dblarr(mchan)


for il=0,mchan-1 do begin
;			    x0    fwhm    itype,     x,      y
       c0v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c0v_s)
       c1v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c1v_s)
       c2v_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, c2v_s)
       gamma(il) =slitavg(chan(il),  fwhm,   itype, l_solv, gammav_s)

       betv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, betv_s)
       rhov_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, rhov_s)
       solv_c(il) =slitavg(chan(il),  fwhm,   itype, l_solv, solv  )
endfor


;	II. Normalize x-sections to average vac ETS flux for each channel:

for il=0,mchan-1 do begin
       c0v_c(il) =c0v_c(il) / solv_c(il)                           
       c1v_c(il) =c1v_c(il) / solv_c(il)                           
       c2v_c(il) =c2v_c(il) / solv_c(il)                            
       alpha228T(il) = c0v_c(il) + c1v_c(il)*(-45.0) + c2v_c(il)*2025.0 
       gamma(il) = gamma(il) / solv_c(il)
	
       betv_c(il) = betv_c(il) / solv_c(il)                            
       rhov_c(il) = rhov_c(il) / solv_c(il)                         
endfor


;	II. Write slit averages                    
close,3    & openw,3, 'coes.alex.test'+citype+cfwhm
printf,3,'lambda Rayleigh King   Ozone Abs. Coe.  H2O     Flux  taum tauc  Refract. Index  albedo'
printf,3,' (um)  (1/atm)  Factor oz0      oz1 oz2 Abs Coe                  Aerosol  Cloud'
printf,3,'                       (1/atm-cm)                                 (x+iy) (x+iy)'                    
;printf,3,mchan
        for il=0,mchan-1 do begin
        printf,3,1.E-03*chan(il),betv_c(il),1.0,c0v_c(il),c1v_c(il),c2v_c(il),0.0,1.00,0.0,0.0,1.5,0.0,1.3,.0,0.02,$
format='(f6.4,f7.4,f5.1,3e12.4,f4.1,f8.5,2f4.1,4f4.1,f7.2)'
        endfor
close,3

close,3    & openw,3, 'F0_alex.test'+citype+cfwhm
printf,3,mchan
        for il=0,mchan-1 do begin
printf,3,1.*chan(il),solv_c(il)                                                                                       
       format='(7e12.4)'
        endfor
close,3




close,3  & close, 31 


stop
end
