pro plot_srf_brewer,ozone,pres_rel,airmass,mode,chan,w_vac_cent,xmin,xmax,w_vac,srf,err_srf,l_solv,ml_solv,solv,betv_s,rhov_s,c0v_s,c1v_s,c2v_s,gammav_s,$
tau_aer_eff,l_rad,e0,w_vac_eff,tau_ray_eff,rho_ray_eff,c0v_eff,c1v_eff,c2v_eff,tau_oz_eff,gammav_eff


; 	srf may need normalization: int(srf)=1
;			SRF re-normalization:
srf_norm_const=int_tabulated(w_vac,srf) & print,'srf_norm_const=', srf_norm_const &  srf=srf/srf_norm_const

ymin=0.0007 & ymax=5.0  ;			PLOT
;               Blue                    Red
;        0  1   2   3   4   5  6    7   8   9   10  11  12  13  14
;       -30 -25 -20 -15 -10 -5      0  +5  +10 +15 +20 +25 +30 +35
rr = [255,000,000,000,000,100,150,000,255,255,255,255,200,150,000]
gg = [255,000,050,100,150,200,220,240,230,150,100,060,020,000,000]
bb = [255,150,240,255,255,255,255,000,230,150,100,060,020,000,000]
col=[0,2,9,11,13,14] & !p.background=0 &  tvlct,rr,gg,bb 
!p.thick=1 & !p.charsize=1.1 &  !p.charthick=1 & !x.thick=3 & !y.thick=4

;plot,w_vac,srf,/nodata,color=14,$
plot_io,w_vac,srf,/nodata,color=14,$
title='Normalized SRF at '+chan+'  GSFC BREWER',$
xtitle='Wavelength (vacuum), nm',xrange=[xmin,xmax],/xstyle,$
yrange=[ymin,ymax],/ystyle,ytitle='Spectral response Function (SRF), nm!u-1!n'

!p.color=13  &  oploterr,w_vac,srf,err_srf ;	srf shifted to vac wavelengths
nw_vac=n_elements(w_vac) & print,'nw_vac=',nw_vac
w_vac_min=min(w_vac) & plots,[w_vac_min,w_vac_min],[0.01,0.07] & xyouts,w_vac_min-0.1,0.10,'!4k!x!dmin!n',charsize=2
w_vac_max=max(w_vac) & plots,[w_vac_max,w_vac_max],[0.01,0.07] & xyouts,w_vac_max,0.10,'!4k!x!dmax!n',charsize=2

!p.color=3 & oplot,l_solv,solv,line=0 			;		 	ETS at vac wavelengths
solv_w=interpol(solv,l_solv,w_vac)  			;	ETS interpolated at SRF vac wavelengths
oplot,w_vac,solv_w*srf,line=0 &  oplot,w_vac,solv_w,psym=2  & xyouts,w_vac(0)-0.25,solv_w(0)-0.1,'E!do!n',charsize=2.8
e0=slit_aver(solv_w,w_vac,srf) & print,'slit_aver: e0',e0 &  ce0='<E!dtop!n>='+string(e0,format='(f6.3)')+' Wm!u-2!nnm!u-1!n' & xyouts,w_vac_min+0.3,3.0,ce0,charsize=1.5

!p.color=11		;	surface flux weighted (effective) wavelength
w_vac_eff=slit_aver(w_vac,w_vac,srf*solv_w) &  print,'slit_aver: w_vac_eff=',w_vac_eff  
t_spec=w_vac/w_vac & l_eff=int_tabulated(w_vac,w_vac*t_spec*solv_w*srf)/int_tabulated(w_vac,t_spec*solv_w*srf) ;& print,'l_eff=',l_eff   
plots,[w_vac_eff,w_vac_eff],[0.01,0.07] & xyouts,w_vac_eff,0.005,'!4k!x!deff!n',charsize=2

!p.color=7	;		Rayleigh at srf vac wavelengths
tau_ray=	pres_rel*interpol(betv_s,l_solv,w_vac)  ; & print,'>plot:  tau_ray=',tau_ray
 tau_ray_leff=interpol(tau_ray,w_vac,w_vac_eff) ;&  print,'tau_ray_eff=',tau_ray_leff
 tau_ray_lcent=interpol(tau_ray,w_vac,w_vac_cent) ;&  print,'tau_ray_cent=',tau_ray_lcent
tau_ray_eff=slit_aver(tau_ray,w_vac,srf*solv_w) & print,'slit_aver: tau_ray_eff=',tau_ray_eff
oplot,w_vac,tau_ray,psym=-1 & xyouts,w_vac(0)-0.16,tau_ray(0),'!4s!x!dRAY!n',charsize=1.8

rho_ray=         interpol(rhov_s,l_solv,w_vac) 
 rho_ray_leff =interpol(rho_ray,w_vac,w_vac_eff) ;&  print,'rho_ray_eff=',rho_ray_leff
 rho_ray_lcent=interpol(rho_ray,w_vac,w_vac_cent) ;&  print,'rho_ray_cent=',rho_ray_lcent
rho_ray_eff=slit_aver(rho_ray,w_vac,srf*solv_w) & print,'slit_aver: rho_ray_eff=',rho_ray_eff

!p.color=1		; ozone absorption
c0v_w=interpol(c0v_s,l_solv,w_vac) & c0v_eff=slit_aver(c0v_w,w_vac,srf*solv_w) & print,'slit_aver: c0v_eff=',c0v_eff
c1v_w=interpol(c1v_s,l_solv,w_vac) & c1v_eff=slit_aver(c1v_w,w_vac,srf*solv_w) & print,'slit_aver: c1v_eff=',c1v_eff
c2v_w=interpol(c2v_s,l_solv,w_vac) & c2v_eff=slit_aver(c2v_w,w_vac,srf*solv_w) & print,'slit_aver: c2v_eff=',c2v_eff
;			TAU_OZ_EFF
TC=-45.0    & alpha45_w=c0v_w + c1v_w*TC + c2v_w*TC*TC & tau_oz=0.001*ozone*alpha45_w ;& print,'tau_oz (-45):' &  print,tau_oz                    
tau_oz_eff=slit_aver(tau_oz,w_vac,srf*solv_w) & print,'slit_aver: tau_oz_eff=',tau_oz_eff

oplot,w_vac,tau_oz,psym=-2 &  xyouts,w_vac(0       )-0.16,tau_oz(0),'!4s!x!dO3!n',charsize=1.8 &  xyouts,w_vac(nw_vac-1)+0.01,tau_oz(nw_vac-1),string(ozone,format='(i3)')+'DU',charsize=1.3
tau_oz_leff =interpol(tau_oz,w_vac,w_vac_eff   ) ;&  print,'tau_oz_leff=',tau_oz_leff
tau_oz_lcent =interpol(tau_oz,w_vac,w_vac_cent) ;&  print,'tau_oz_lcent=',tau_oz_lcent
c0v_cent =interpol(c0v_w,w_vac,w_vac_cent) ;&  print,'c0v_cent=',c0v_cent
c1v_cent =interpol(c1v_w,w_vac,w_vac_cent) ;&  print,'c1v_cent=',c1v_cent
c2v_cent =interpol(c2v_w,w_vac,w_vac_cent) ;&  print,'c2v_cent=',c2v_cent

!p.color=11
xyouts,w_vac_eff+0.05,0.06,'<!4s!x!dRAY!n>!deff!n=',charsize=1.5 &  xyouts,w_vac_eff+0.30,0.06,string(tau_ray_eff,format='(f5.3)'),charsize=1.2
;xyouts,w_vac_eff+0.05,0.06,'!4s!x!dRAY!n(!4k!x!deff!n)=',charsize=1.5 &  xyouts,w_vac_eff+0.30,0.06,string(tau_ray_leff,format='(f5.3)'),charsize=1.2
xyouts,w_vac_eff+0.05,0.03,'<!4q!x(!4k!x>!deff!n=',charsize=1.5 &         xyouts,w_vac_eff+0.30,0.03,string(rho_ray_eff,format='(f6.4)'),charsize=1.2
;xyouts,w_vac_eff+0.05,0.03,'!4q!x(!4k!x!deff!n)=',charsize=1.5 &         xyouts,w_vac_eff+0.30,0.03,string(rho_ray_leff,format='(f6.4)'),charsize=1.2
xyouts,w_vac_eff+0.05,0.01,'<!4s!x!dO3!n>!deff!n=',charsize=1.5 &   xyouts,w_vac_eff+0.30,0.01,string(tau_oz_eff,format='(f5.3)'),charsize=1.2
;xyouts,w_vac_eff+0.05,0.01,'!4s!x!dO3!n(!4k!x!deff!n)=',charsize=1.5 &   xyouts,w_vac_eff+0.30,0.01,string(tau_oz_eff,format='(f5.3)'),charsize=1.2


; 			TAU_SO2_EFF
!p.color=14	; SO2 absorption at vac wavelengths
tcso2=0.001		; 1DU of SO2
gammav_w=interpol(gammav_s,l_solv,w_vac) &  tau_so2=tcso2*gammav_w
oplot,w_vac,tau_so2,line=02 &  xyouts,w_vac(0)-0.16,tau_so2(0),'!4s!x!dSO2!n',charsize=1.8
xyouts,w_vac(nw_vac-1)+0.01,tau_so2(nw_vac-1),string(tcso2,format='(i3)')+'DU',charsize=1.3
tau_so2_leff =interpol(tau_so2,w_vac,w_vac_eff   ) ;&  print,'tau_so2_leff=',tau_so2_leff
tau_so2_lcent =interpol(tau_so2,w_vac,w_vac_cent) ;&  print,'tau_so2_lcent=',tau_so2_lcent
gammav_lcent =interpol(gammav_w,w_vac,w_vac_cent) ;&  print,'gammav_lcent=',gammav_lcent
gammav_eff=slit_aver(gammav_w,w_vac,srf*solv_w) & print,'slit_aver: gammav_eff=',gammav_eff


; 	Aerosol extinction
tau_aer=36.8/w_vac
;print,'tau_aer:' &  print,tau_aer                   

!p.color=11	;		Total extinction
t_spec=exp(-airmass*(tau_ray + tau_aer +tau_oz))	; calculated spectral transmittance
oplot,w_vac,t_spec*solv_w*srf

e_bot=int_tabulated(w_vac,t_spec*solv_w*srf)  ;& print,'e_bot=',e_bot
ce_bot='<E!dbot!n>='+string(e_bot,format='(f7.5)')+' Wm!u-2!nnm!u-1!n' & xyouts,w_vac_min+0.3,0.0020,ce_bot,charsize=1.5
xyouts,w_vac_min+0.3,0.0010,'Airmass=',charsize=1.5  & xyouts,w_vac_min+0.5,0.0010,airmass                  
t_meas=e_bot/e0		; "Measured transmittance"
;print,'Transmittance=',t_meas  
;plots,[w_vac_min,w_vac_max],t_meas*[1,1]
;print,'Airmass=',airmass & print,'Ozone=',ozone & print,'Pressure=',pres_rel &  print,'E_bot=',e_bot    


;			Equivalent Radiative Wavelength
l_rad=interpol(double(w_vac),double(t_spec),double(t_meas)) ;& print,'			L_rad=',l_rad
if  abs(l_rad(0)-w_vac_eff) gt 0.5  then begin	; check closeness to w_vac_eff
print,'!!! l_rad too far from w_vac_eff !!!'  & print,l_rad(0),w_vac_eff
for i=1,nw_vac-5 do begin	; start removing shorter wavelengths iteratively 
l_rad=interpol(double(w_vac(i:nw_vac-1)),double(t_spec(i:nw_vac-1)),double(t_meas)) 
print,'l_rad,w_vac_eff',i,l_rad,w_vac_eff
if  abs(l_rad(0)-w_vac_eff) le 0.5  then goto,quit	; check w_vac_eff closiness            
endfor
print,'	!!! Fails to find L_rad: L_rad=L_eff  '
l_rad=w_vac_eff
endif 

quit:		; END L_rad calculation

!p.color=11
;print,'w_vac_min,w_vac_max,w_vac_eff,l_rad=',w_vac_min,w_vac(nw_vac-1),w_vac_eff,l_rad(0)
;plots,[l_rad(0),l_rad(0)],[0.001,0.07] & xyouts,l_rad(0)+0.1,0.030,'!4k!x!drad!n'

;if tau_ray_eff(0) gt max(tau_ray) or tau_ray_eff(0) lt min(tau_ray) then begin & print,'!!! tau_ray_eff outside boundaries: ' & print,tau_ray_eff(0),min(tau_ray),max(tau_ray)  & stop & endif 
;tau_aer_eff=interpol(tau_aer,w_vac,w_vac_eff) &  print,'tau_aer_eff=',tau_aer_eff
;tau_aer_eff=interpol(tau_aer,w_vac,l_rad(0)) &  print,'tau_aer_eff(0)=',tau_aer_eff(0)
;if tau_aer_eff(0) gt max(tau_aer) or tau_aer_eff(0) lt min(tau_aer) then begin & print,'	!!! tau_aer_eff(0) outside boundaries !!!' & stop & endif


!p.color=13
plots,[w_vac_cent,w_vac_cent],[0.01,0.07] & xyouts,w_vac_cent-0.05,0.10,'!4k!x!dcent!n',charsize=2
xyouts,w_vac_cent-0.45,0.06,'!4s!x!dRAY!n(!4k!x!dcent!n)=',charsize=1.5
ctau_ray_lcent=string(tau_ray_lcent,format='(f5.3)') &  xyouts,w_vac_cent-0.20,0.06,ctau_ray_lcent,charsize=1.2
xyouts,w_vac_cent-0.45,0.03,'!4q!x(!4k!x!dcent!n)=',charsize=1.5
crho_ray_lcent=string(rho_ray_lcent,format='(f6.4)') &  xyouts,w_vac_cent-0.18,0.03,crho_ray_lcent,charsize=1.2
xyouts,w_vac_cent-0.45,0.01,'!4s!x!dO3!n(!4k!x!dcent!n)=',charsize=1.5
ctau_oz_lcent=string(tau_oz_lcent,format='(f5.3)') &  xyouts,w_vac_cent-0.20,0.01,ctau_oz_lcent,charsize=1.2

;
l=findgen(10)*0.1 + 340
;oplot,l,l/l*(0.3),line=0,color=col(1)  
;xyouts,335,0.3,file,charsize=1.0,color=col(1)

;if mode ne 'screen' then device,/close
return
end
