pro read_coe, filename, nheader,ml,lv, c0v,c1v,c2v,betv,rho,header

;		INPUT
;	 filename 
; ml - number of tomrad wavelengths

;		OUTPUT
; lv - tomrad vac wavelength in nm
; c0v
; c1v
; c2v
; betv
; rho   - depolarization factor
; header - 


;		I. read TOMRAD spectral flux components

openr,1,filename           
header='' & for i=0,nheader-1 do readf,1,header
;print,'read_coe:	',header
a=dblarr(6,ml) & readf,1,a & close,1

;		file explanation:
;    WLVAC         C0           C1           C2           BETA         RHO
; 2.50000e+03  2.99762e+02 -4.79650e-02 -3.95337e-04  2.71596e+00  3.56083e-02


lv =0.1*reform(a(0,*))    ;  lv - vac wavelength in nm
c0v=    reform(a(1,*))
c1v=    reform(a(2,*))
c2v=    reform(a(3,*))
betv=   reform(a(4,*))
rho =   reform(a(5,*))

;		V. No Multiply ZUV by solar constant [W/m2/nm]
; 		VI. No Shift to air wavelengths
;		VII. Wavelength averaging
;			NONE

return
end

