pro read_no2,filename,nrows,l_v,	no2_220K,no2_294K

; nrows - number of spectral points in file
;		OUTPUT
; l_v - NO2 absorption coefficient wavelengths [nm], vac
; no2_220K - NO2 absorption coefficient at 220K [atm-cm-1] 
; no2_294K - NO2 absorption coefficient at 294K [atm-cm-1] 

;  Reference to NO2 X section measurements
; NO2 Absorption cross sections, cm2/molecule at 220K & 294K, from CD: no2_220k_s3.txt & no2_294k_s2.txt
;Vandaele A.C., C. Hermans, P.C. Simon, M. Carleer, R. Colin, S. Fally, M.F. M#ienne, A. Jenouvrier, and B. Coquart
; J.Q.S.R.T., 59, 171-184 (1998)
; 3.2151617e+002  2.5157600e-019  2.3893400e-019

close,2 & openr,2,filename                                       
no2_dat=dblarr(3,nrows)  
x='' & for i=0,3 do readf,2,x & readf,2,no2_dat & close,2 & print,x
l_a=1.00*reform(no2_dat(0,*)) & ml_no2=n_elements(l_a) &  print,'ml_no2=',ml_no2

airvac,l_a, l_v     ; shift to vac wavelengths
;    for i=0,ml_no2-1 do print,l_a(i),l_v(i),l_v(i)-l_a(i), format='(f8.4,2x,f8.4,2x,f8.4)'

Nlosch=2.686745D+19
  no2_220K=Nlosch*reform(no2_dat(1,*))       ;       convert x-section 220K to abs_coeff [atm-cm-1]
  no2_294K=Nlosch*reform(no2_dat(2,*))       ;       convert x-section 294K to abs_coeff [atm-cm-1]

return
end

