pro read_solar,filename,norm,doy,m_header,n_data,l_solv,ml_solv,solv

;	INPUT
; filename	: source file with source file with high resolution ETS 
;	ASSUMPTIONS: 
;			-vacuum wavelengths 
;			- 1AU sun-Earth distance
;			- Spectral range of teh source is larger than spectral range of smoothed data
;
; norm		: multiplication factor to Watts/m2/nm (norm=0.001 is source flux is in [mWatts/m2/nm] )
; doy	: day of year for sun-Earth distance correction (doy=275 correspondes to R2~1)
; m_header	: number of header lines
; n_data	: number of data lines          
;	OUTPUT
; l_solv	: 	vac wavelengths of the ETS
; ml_solv	: 	number of ETS vac wavelengths
; solv		: 	ETS values at sun-Earth distance of doy in [W/m2/nm]

;openr,2,'/home/krotkov/mayer_vac_ipmmi.txt'
openr,2,filename                                        & sol_dat=fltarr(2,n_data)
;sol_dat=fltarr(2,8479)
x='' & for i=0,m_header-1 do readf,2,x & readf,2,sol_dat & close,2 & print,x
;x='' & for i=0,13 do readf,2,x & readf,2,sol_dat & close,2 & print,x
l_solv=      reform(sol_dat(0,*)) & ml_solv=n_elements(l_solv) &  print,'ml_solv=',ml_solv
  solv=norm*reform(sol_dat(1,*))       ;       convert to [W/(m2 nm)]
;  solv=0.001*reform(sol_dat(1,*))       ;       convert to [W/(m2 nm)]

;       Sun-Earth distance correction on doy                       
dist=sol_dist_kelly(doy) & print,dist^2
;dist=sol_dist(doy) & print,dist^2
solv=solv/dist^2
return
end

