function ffunct,w,w0,fwhm,itype
;
; filter function (normalized to unit area)
;
ni=n_elements(w)
if(itype eq 0)then begin  ; rect.
 f=fltarr(ni) & f(*)=1./fwhm
endif else if(itype eq 1)then begin  ; tri.
 f=(1.0-abs(w-w0)/fwhm)/fwhm
 f(0)=0.0 & f(ni-1)=0.0
endif else if(itype eq 2)then begin  ; exp(triangle)
 a=2.*alog(2.)/fwhm
 f=exp(-a*abs(w-w0))
endif else if(itype eq 3)then begin  ; gaussian
; sig=(fwhm/2.)/sqrt(2.*alog(2.))
; f=exp(-(w-w0)*(w-w0)/2./sig/sig)
 f=exp(-4.*alog(2)*((w-w0)/fwhm)^2)
endif else if(itype eq 4)then begin  ; lore filters
; read the 2nm filter
 onr,'/home/flittner/limb/solse2/forward/modtran/limb/lore2_chan2nm.dat',wl,fl
 wl=wl*1.0e-03
; strecth or compress to fit the fwhm
 i=where((fl/max(fl) lt .5) and (wl lt 0.),ic)
 i=i(ic-1)
 p1=wl(i)*(fl(i+1)/max(fl)-.5)/(fl(i+1)/max(fl)-fl(i)/max(fl)) + $
    wl(i+1)*(.5-fl(i)/max(fl))/(fl(i+1)/max(fl)-fl(i)/max(fl))
 i=where((fl/max(fl) lt .5) and (wl gt 0.))
 i=i(0)
 p2=wl(i)*(fl(i-1)/max(fl)-.5)/(fl(i-1)/max(fl)-fl(i)/max(fl)) + $
    wl(i-1)*(.5-fl(i)/max(fl))/(fl(i-1)/max(fl)-fl(i)/max(fl))
 old_fwhm=p2-p1
 if(fwhm gt old_fwhm)then begin
  dw=(fwhm-old_fwhm)/2.
  i=where(wl lt 0.)
  j=where(wl gt 0.)
  wl(i)=wl(i)-dw
  wl(j)=wl(j)+dw
  tmpw1=wl(i)
  tmpw2=wl(j)
  tmpf1=fl(i)
  tmpf2=fl(j)
 endif else if (fwhm lt old_fwhm)then begin
  dw=(old_fwhm-fwhm)/2.
  i=where(wl lt 0.,ic)
  ii=where(wl(i) lt -dw,iic)
  tmpw1=wl(i(ii))+dw
  tmpf1=fl(i(ii))
  i=where(wl gt 0.,ic)
  ii=where(wl(i) gt dw,iic)
  tmpw2=wl(i(ii))-dw
  tmpf2=fl(i(ii))
 endif
 i0=where(wl eq 0.,i0c)
 if(i0c eq 1)then begin
  tmpw1=[tmpw1,wl(i0)]
  tmpf1=[tmpf1,fl(i0)]
 endif
 wl=[tmpw1,tmpw2]
 fl=[tmpf1,tmpf2]
; normalize to unity
 nf=n_elements(fl)
 sum=0.5*total((fl(0:nf-2)+fl(1:nf-1))*(wl(1:nf-1)-wl(0:nf-2)))
 fl=fl/sum
 f=lint(w0+wl,fl,w)
endif else if(itype eq 5)then begin
; a rect. of FWHM=fwhm[0] convolved with a rect. of FWHM=fwhm[1]
 a1=max(fwhm)
 a2=min(fwhm)
 da=a1-a2
 if(da le 0.)then da=0.
 x1=w0-da*0.5
 x0=x1-a2
 x2=w0+da*0.5
 x3=x2+a2
 f=fltarr(ni)
 i=where(w le x0,ic) & if(ic gt 0)then f[i]=0.
 i=where(w ge x3,ic) & if(ic gt 0)then f[i]=0.
 i=where(w gt x0 and w lt x3,ic) & if(ic gt 0)then f[i]=1.
 i=where(w gt x0 and w lt x1,ic) & if(ic gt 0)then f[i]=(1.0-abs(w[i]-x1)/a2)
 i=where(w gt x2 and w lt x3,ic) & if(ic gt 0)then f[i]=(1.0-abs(w[i]-x2)/a2)
 sum=0.5*total((f[1:ni-1]+f[0:ni-2])*(w[1:ni-1]-w[0:ni-2]))
 f=f/sum
endif else if(itype eq 6)then begin  ; exp(gaussian)
 gomoslsf,w-w0,fwhm,f
 sum=0.5*total((f[1:ni-1]+f[0:ni-2])*(w[1:ni-1]-w[0:ni-2]))
 f=f/sum
endif
return,f
end
;
;
function slitavg,x0,fwhm,itype,x,y
;
; compute slit average of data y(x) centered at w0 with fwhm
;
; steps:
; 1. interpolate y(x) at wmin,w0,wmax
; 2. use these points along with all interior points in trapaziodal integration.
;
; input:
; x0 - center of filter
; fwhm - full width at half max of filter
; itype - type of filter (0=rectangular, 1=triangle,2=e(tri),3=gaussian,4=2nm)
; x - independent variable
; y - dependent variable
;
; output:
; yout - y(x) averaged at x0 using the filter
;
; last mod. Feb. 10, 1998...def
; purpose: add 2 more options for slit functions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;rcs stuff
; $Header: /n/flittner/limb/inv/idl/RCS/slitavg.pro,v 1.1 1997/11/11 19:20:37 flittner Exp flittner $
; $Log: slitavg.pro,v $
;Revision 1.1  1997/11/11  19:20:37  flittner
;Initial revision
;
;
tol=1.0e-08
;
uselint=1
nw=n_elements(x0)
if(itype eq 5)then begin
 size_fwhm=size(fwhm)
 if(size_fwhm[0] eq 1)then begin
  nfwhm=1
  thefwhm=fwhm(0:1)
 endif else begin
  nfwhm=size_fwhm[2]
  thefwhm=reform(fwhm[0:1,*])
 endelse
endif else if(itype eq 6)then begin
 size_fwhm=size(fwhm)
 if(size_fwhm[0] eq 1)then begin
  nfwhm=1
  thefwhm=fwhm(0:2)
 endif else begin
  nfwhm=size_fwhm[2]
  thefwhm=reform(fwhm[0:2,*])
 endelse
endif else begin
 nfwhm=n_elements(fwhm)
 thefwhm=fwhm(0)
endelse
yout=x0
;
; loop for each x0
;
; will spline y(x)
;
y2=spl_init(x,y)
;
for i=0,nw-1 do begin
 if(nfwhm gt 1)then begin
  if(itype eq 5)then begin
   thefwhm=reform(fwhm(0:1,i))
  endif else if(itype eq 6)then begin
   thefwhm=reform(fwhm(0:2,i))
  endif else begin
   thefwhm=fwhm(i)
  endelse
 endif
;find min & max w
 if(itype eq 0)then begin
; rect.
  wmin=x0(i)-0.5*thefwhm
  wmax=x0(i)+0.5*thefwhm
 endif else if(itype eq 1)then begin
; triangle
  wmin=x0(i)-thefwhm
  wmax=x0(i)+thefwhm
 endif else if(itype eq 2)then begin
; exp(triangle)
  wmin=x0(i)-(alog(100.)/alog(0.5))*thefwhm/2.
  wmax=x0(i)+(alog(100.)/alog(0.5))*thefwhm/2.
 endif else if(itype eq 3)then begin
; gaussian=exp(-x^2 /2/sig^2)
  wmin=x0(i)-sqrt(alog(100./0.5)/alog(2.))*thefwhm/2.
  wmax=x0(i)+sqrt(alog(100./0.5)/alog(2.))*thefwhm/2.
 endif else if(itype eq 4)then begin
; lore filter with 2nm fwhm
  wmin=x0(i)-3.0*thefwhm
  wmax=x0(i)+3.0*thefwhm
 endif else if(itype eq 5)then begin
; rect. convolved with a rect.
  wmin=x0(i)-0.5*thefwhm[0]-thefwhm[1]
  wmax=x0(i)+0.5*thefwhm[0]+thefwhm[1]
 endif else if(itype eq 6)then begin  ; exp(gaussian)
  wmin=x0(i)-4.0*thefwhm[2]
  wmax=x0(i)+4.0*thefwhm[2]
 endif
; interpolate y(x) to wmin,wmax
 if(uselint)then begin
  yends=lint(x,y,[wmin,x0(i),wmax])
 endif else begin
  yends=spl_interp(x,y,y2,[wmin,x0(i),wmax])
 endelse
; find data points that are between wmin,wmax
 j=where((x gt wmin+tol) and (x lt wmax-tol),jc)
 if(jc eq 0)then begin
  if(itype eq 0)then begin
   dx=[x0(i),wmax,wmax]-[wmin,wmin,x0(i)]
   yout(i)=0.5*total(yends*dx)/thefwhm
  endif else begin
   yout(i)=yends(1)
  endelse
 endif else begin
  xx=[wmin,x0(i),wmax,x(j)]
  yy=[yends,y(j)]
  ii=sort(xx)
  xx=xx(ii)
  yy=yy(ii)
  ni=jc+3
  dx=[xx(1)-xx(0),xx(2:*)-xx(0:ni-1-2),xx(ni-1)-xx(ni-2)]
  w=ffunct(xx,x0(i),thefwhm,itype)
  yout(i)=total(w*dx*yy)/total(w*dx)
;openw,12,'slitavg.out'
;for ji=0,n_elements(w)-1 do printf,12,xx(ji),w(ji),yy(ji),dx(ji)
;close,12
 endelse
; if(i ge 20)then begin
;  if(i-(i/(nw/20))*(nw/20) eq 0)then print,'x0 = ',x0(i),yout(i)
; endif
endfor
;
return,yout
end
