;
;  read in coefficients data file
;
bass=fltarr(6,3047)
file_name='/misc/cgw/source/v7simtoms/BASS_2.DAT'
openr,iunit, file_name, /get_lun
readf,iunit,bass
close,iunit
free_lun, iunit
;
;  define set of bass wavelengths surrounding band center wavelength (bcw)
;
fwhm=11.32
wavs=fltarr(6,5)
spc=['ad','ep','n7','m3','gm']
wavs(*,0)=[3087.3,3126.4,3176.6,3224.5,3313.6,3601.7]
wavs(*,1)=[3087.0,3126.1,3176.2,3224.2,3313.4,3601.5]
wavs(*,2)=[3123.4,3173.5,3310.6,3396.6,3598.8,3799.5]
wavs(*,3)=[3124.0,3174.5,3311.8,3397.8,3600.5,3802.1]
wavs(*,4)=[3100.0,3125.0,3175.0,3310.0,3600.0,3850.0]
ns=[5,5,4,4,4]
;
for ispc=0,4 do begin
;
n=ns(ispc)
czro=fltarr(n) & cone=fltarr(n) & ctwo=fltarr(n)
for i=0,n-1 do begin
bcw=wavs(i,ispc)
intgrl=where(abs(bass(0,*)-bcw) lt fwhm,nint)
wav=reform(bass(0,intgrl))
dlam=abs(wav-bcw)
slit=1.0-abs(dlam)/fwhm
c0=reform(bass(1,intgrl))
c1=reform(bass(2,intgrl))
c2=reform(bass(3,intgrl))
;
;  get solar flux for weighting
;
sols=fltarr(2,2047)
file_name='/misc/cgw/source/v8tables/SOLSTICE'
openr,iunit, file_name, /get_lun
readf,iunit,sols
close,iunit
free_lun, iunit
flux=interpol(sols(1,*),sols(0,*),wav)
;
; calculate integral in straight forward fashion (this approach gives
; different answers at high sza and non-zero scan angles)
;
czro(i)=total(flux*slit*c0)/total(flux*slit)
cone(i)=total(flux*slit*c1)/total(flux*slit)
ctwo(i)=total(flux*slit*c2)/total(flux*slit)
;
endfor
;
print,spc(ispc)
print,czro,format="(5(e9.3,','))"
print,cone,format="(5(e9.3,','))"
print,ctwo,format="(5(e9.3,','))"
;
;  sbuv formatting statement
;
;format="(6x,'data c0',a3,'/',4(e10.3,',')/(5x,'1',11x,4(e10.3,',')/))"
;
endfor
;
end
