;
;  read in coefficients data file
;
bass=fltarr(6,3047)
file_name='/misc/cgw/source/v7simtoms/BASS_2.DAT'
openr,iunit, file_name, /get_lun
readf,iunit,bass
close,iunit
free_lun, iunit
;
;  define sets of band center wavelengths (bcw)
;
fwhm=11.32
wavs=fltarr(8,8)
spc=['n07','n09','n11','n14','n16','n17','ssb','n04']
wavs(*,0)=[2923.0,2976.0,3020.0,3059.0,3126.0,3176.0,3313.0,3399.0]
wavs(*,1)=[2921.4,2974.1,3018.0,3057.4,3124.3,3174.4,3311.5,3397.5]
wavs(*,2)=[2923.2,2975.9,3019.8,3058.5,3125.5,3175.5,3312.6,3398.7]
wavs(*,3)=[2922.6,2975.4,3019.3,3058.0,3125.0,3175.1,3312.3,3398.4]
wavs(*,4)=[2922.91,2975.68,3019.55,3058.95,3125.87,3175.91,3312.25,3398.98]
wavs(*,5)=[2921.78,2975.34,3019.25,3057.95,3124.94,3175.03,3312.22,3398.30]
wavs(*,6)=[292.37,297.65,302.04,305.98,312.68,317.68,331.39,339.99]*10.0
wavs(*,7)=[2922.89,2975.86,3019.72,3058.72,3125.65,3175.61,3312.61,3398.92]
;
n=8
;
for ispc=0,7 do begin
;
czro=fltarr(n) & cone=fltarr(n) & ctwo=fltarr(n)
for i=1,n-1 do begin
bcw=wavs(i,ispc)
;
;  define set of bass wavelengths surrounding band center wavelength (bcw)
;
intgrl=where(abs(bass(0,*)-bcw) lt fwhm,nint)
wav=reform(bass(0,intgrl))
dlam=abs(wav-bcw)
slit=1.0-abs(dlam)/fwhm
c0=reform(bass(1,intgrl))
c1=reform(bass(2,intgrl))
c2=reform(bass(3,intgrl))
;
;  get solar flux for weighting (move read out of loop)
;
sols=fltarr(2,2047)
file_name='/misc/cgw/source/v8tables/SOLSTICE'
openr,iunit, file_name, /get_lun
readf,iunit,sols
close,iunit
free_lun, iunit
flux=interpol(sols(1,*),sols(0,*),wav)
;
; calculate integral
;
czro(i)=total(flux*slit*c0)/total(flux*slit)
cone(i)=total(flux*slit*c1)/total(flux*slit)
ctwo(i)=total(flux*slit*c2)/total(flux*slit)
;
endfor
;
print,'c  ',spc(ispc)
print,spc(ispc),czro, $
format="(6x,'data c0',a3,'/',4(e10.3,',')/(5x,'1',11x,4(e10.3,',')/))"
print,spc(ispc),cone, $
format="(6x,'data c1',a3,'/',4(e10.3,',')/(5x,'1',11x,4(e10.3,',')/))"
print,spc(ispc),ctwo, $
format="(6x,'data c2',a3,'/',4(e10.3,',')/(5x,'1',11x,4(e10.3,',')/))"
;
endfor
;
end
