set_plot,'ps'
device,filename='compare.ps',xoffset=2,yoffset=2,ysize=24
cartrn=''
;
!p.charthick=2.0
!p.charsize=1.5
!p.thick=2.0
!x.thick=2.0
!y.thick=2.0
;
hdr=''
bass=fltarr(6,1601)
bass=fltarr(6,1521)
openr,1,'BSBR_V8.DAT'
;openr,1,'../v8tables/BSBR_V8.DAT'
readf,1,hdr
readf,1,bass
close,1
;
brmn=fltarr(6,1601)
brmn=fltarr(6,1521)
openr,1,'BRMN_V8.DAT'
;openr,1,'../v8tables/BRMN_V8.DAT'
readf,1,hdr
readf,1,brmn
close,1
;
frnc=fltarr(6,1601)
frnc=fltarr(6,1521)
openr,1,'FRNC_V8.DAT'
;openr,1,'../v8tables/FRNC_V8.DAT'
readf,1,hdr
readf,1,frnc
close,1
;
tmp=-47.0
basst=reform(bass(1,*)+bass(2,*)*tmp+bass(3,*)*tmp*tmp)
brmnt=reform(brmn(1,*)+brmn(2,*)*tmp+brmn(3,*)*tmp*tmp)
frnct=reform(frnc(1,*)+frnc(2,*)*tmp+frnc(3,*)*tmp*tmp)
;
bassdt=reform(bass(2,*)+2.0*bass(3,*)*tmp)/basst*1000.0
brmndt=reform(brmn(2,*)+2.0*brmn(3,*)*tmp)/brmnt*1000.0
frncdt=reform(frnc(2,*)+2.0*frnc(3,*)*tmp)/frnct*1000.0
;
dfbsdt=(bassdt-brmndt)
dffrdt=(frncdt-brmndt)
;
diffb=(basst-brmnt)
difff=(frnct-brmnt)
pdiffb=(basst-brmnt)/brmnt*100.0
pdifff=(frnct-brmnt)/brmnt*100.0
;
lamda=reform(bass(0,*))/10.0
ranges=fltarr(2,10)
ranges(0,*)=[254,264,274,284,294,304,314,324,334,344]
ranges(1,*)=[266,276,286,296,306,316,326,336,346,356]
;
;  maursberger normalization is at 253.7 nm (37)
;
ratbrmn=bass(1,37)/brmn(1,37)
ratbrmnt=basst(37)/brmnt(37)
ratfrnc=bass(1,37)/frnc(1,37)
ratfrnct=basst(37)/frnct(37)
print,'ratbrmn,ratbrmnt,ratfrnc,ratfrnct'
print,ratbrmn,ratbrmnt,ratfrnc,ratfrnct
;
;  check differences at TOMS wavelengths, ad, ep, n7, m3
;
wltoms=[3087.3,3126.4,3176.6,3224.5,3313.6,3601.7, $
        3087.0,3126.1,3176.2,3224.2,3313.4,3601.5, $
        3123.4,3173.5,3310.6,3396.6,3598.8,3799.5, $
        3124.0,3174.5,3311.8,3397.8,3600.5,3802.1]
;
bsstms=interpol(basst,lamda,wltoms)
brmtms=interpol(brmnt,lamda,wltoms)
dbrmtms=interpol(diffb,lamda,wltoms)
pbrmtms=interpol(pdiffb,lamda,wltoms)
frntms=interpol(frnct,lamda,wltoms)
dfrntms=interpol(difff,lamda,wltoms)
pfrntms=interpol(pdifff,lamda,wltoms)
;
print,' Table of Bremen - Bass Absorption Coefficients'
print,'            ADEOS TOMS Wavelengths'
print,'Wavelength    Bass     Brmn     Difference Percent'
for lmd=0,23 do print,wltoms(lmd),bsstms(lmd),brmtms(lmd),dbrmtms(lmd),pbrmtms(lmd), $
      format='(f9.2,3f10.3,f10.2)'
;
;  plot absorption coefficients and differences
;
!p.multi=[0,0,3,0,0]
;
for iplt=0,9 do begin
;
thsxrng=reform(ranges(*,iplt))
;
x=[lamda,lamda,lamda] & y=[basst,brmnt,frnct]
plot,x,y,xrange=thsxrng,xstyle=1,ystyle=16, $
  xtitle='Wavelength',ytitle='Difference (atm-cm-1)', $
  title='Difference from Bremen FTS',/nodata
  oplot,lamda,basst
  oplot,lamda,brmnt,linestyle=1
  oplot,lamda,frnct,linestyle=2
  x=[0.75,0.78]
  y=[0.96,0.96]
  plots,x,y,/normal
  xyouts,0.80,0.956,'Bass',/normal,charsize=1.0
  x=[0.75,0.78]
  y=[0.94,0.94]
  plots,x,y,/normal,linestyle=1
  xyouts,0.80,0.936,'Bremen',/normal,charsize=1.0
  x=[0.75,0.78]
  y=[0.92,0.92]
  plots,x,y,/normal,linestyle=2
  xyouts,0.80,0.916,'French',/normal,charsize=1.0
;
x=[lamda,lamda] & y=[diffb,difff]
plot,x,y,xrange=thsxrng,xstyle=1, $
  xtitle='Wavelength',ytitle='Difference (atm-cm-1)', $
  title='Difference from Bremen FTS',/nodata
  oplot,lamda,diffb
  oplot,lamda,difff,linestyle=1
  x=[0.75,0.78]
  y=[0.412,0.412]
  plots,x,y,/normal
  xyouts,0.80,0.408,'Bass - Brmn',/normal,charsize=1.0
  x=[0.75,0.78]
  y=[0.392,0.392]
  plots,x,y,/normal,linestyle=1
  xyouts,0.80,0.388,'Frnc - Brmn',/normal,charsize=1.0
;
x=[lamda,lamda] & y=[pdiffb,pdifff]
plot,x,y,xrange=thsxrng,xstyle=1, $
  xtitle='Wavelength',ytitle='Difference (%)', $
  title='Difference from Bremen FTS',/nodata
  oplot,lamda,pdiffb
  oplot,lamda,pdifff,linestyle=1
  x=[0.75,0.78]
  y=[0.08,0.08]
  plots,x,y,/normal
  xyouts,0.80,0.076,'Bass - Brmn',/normal,charsize=1.0
  x=[0.75,0.78]
  y=[0.06,0.06]
  plots,x,y,/normal,linestyle=1
  xyouts,0.80,0.056,'Frnc - Brmn',/normal,charsize=1.0
;read,cartrn
;
endfor
;
;  plot temperature sensitivities and differences
;
!p.multi=[0,0,2,0,0]
;
for iplt=0,9 do begin
;
thsxrng=reform(ranges(*,iplt))
;
x=[lamda,lamda,lamda] & y=[bassdt,brmndt,frncdt]
plot,x,y,xrange=thsxrng,xstyle=1, $
  xtitle='Wavelength (nm)',ytitle='% / 10 Degree C', $
  title='Temperature Sensitivity at -47 C',/nodata
  oplot,lamda,bassdt
  oplot,lamda,brmndt,linestyle=1
  oplot,lamda,frncdt,linestyle=2
  x=[0.21,0.24]
  y=[0.93,0.93]
  plots,x,y,/normal
  xyouts,0.26,0.927,'Bass',/normal,charsize=1.0
  x=[0.21,0.24]
  y=[0.91,0.91]
  plots,x,y,/normal,linestyle=1
  xyouts,0.26,0.907,'Bremen',/normal,charsize=1.0
  x=[0.21,0.24]
  y=[0.89,0.89]
  plots,x,y,/normal,linestyle=2
  xyouts,0.26,0.887,'French',/normal,charsize=1.0
;
x=[lamda,lamda] & y=[dfbsdt,dffrdt]
plot,x,y,xrange=thsxrng,xstyle=1, $
  xtitle='Wavelength (nm)',ytitle='% / 10 Degree C', $
  title='Sensitivity Difference at -47 C',/nodata
  oplot,lamda,dfbsdt
  oplot,lamda,dffrdt,linestyle=1
  x=[0.74,0.77]
  y=[0.13,0.13]
  plots,x,y,/normal
  xyouts,0.79,0.127,'Bass - Brmn',/normal,charsize=1.0
  x=[0.74,0.77]
  y=[0.11,0.11]
  plots,x,y,/normal,linestyle=1
  xyouts,0.79,0.107,'Frnc - Brmn',/normal,charsize=1.0
;read,cartrn
;
endfor
;
device,/close
;
end
