;set_plot,'ps'
;device,filename='frenchfts.ps',xoffset=2,yoffset=2,ysize=24
;!p.multi=[0,0,2,0,0]
cartrn=''
;
!p.charthick=2.0
!p.charsize=1.5
!p.thick=2.0
!x.thick=2.0
!y.thick=2.0
;
;  the french data have quadratic temperature dependence in kelvin
;
data=fltarr(4,9617)
OPENR,1, 'O3_NEW_K.DAT'
READF,1,data
lamda=data(0,*)*10.0
close,1
;
alfat=data(1,*)+data(2,*)*226.0+data(3,*)*226.0^2
plot,lamda,alfat
read,cartrn
;
;  convert to quadratic in degrees celsius and absorption coefficient
;  Mauersberger normalization, m0 is unecessary
;
m0=1.0
k0=273.14
cdata=data
cdata(1,*)=(data(1,*)+data(2,*)*k0+data(3,*)*k0^2)*0.26868*m0
cdata(2,*)=(data(2,*)+data(3,*)*2.0*k0)*0.26868*m0
cdata(3,*)=(data(3,*))*0.26868*m0
;
lmdout=findgen(951)+2500.0
newdata=fltarr(4,951)
newdata(0,*)=lmdout
for i=1,3 do begin
  y=reform(cdata(i,*))
  newdata(i,*)=interpol(y,lamda,lmdout)
  plot,lamda,cdata(i,*),linestyle=1
  read,cartrn
  oplot,newdata(0,*),newdata(i,*)
  read,cartrn
endfor
;
;  create output file in tomrad format using bass file as template
;
;  read in bass coefficients
;    WLVAC         C0           C1           C2           BETA         RHO
; 3.07139E+03  3.88057E+00  1.01524E-02  4.67511E-05  1.09969E+00  3.17000E-02
;
hdr='    WLVAC         C0           C1           C2           BETA         RHO'
data=fltarr(6,1601)
openr,1,'BASS_V8.DAT'
readf,1,hdr
readf,1,data
close,1
;
brmn=fltarr(6,1601)
openr,1,'BRMN_V8.DAT'
readf,1,hdr
readf,1,brmn
close,1
;
help,newdata
data(0:3,0:950)=newdata
data(0:3,948:1600)=brmn(0:3,948:1600)
;
openw,1,'FRNC_V8.DAT'
printf,1,hdr
for i=0,1600 do printf,1,data(*,i),format='(e12.5,6e13.5)'
close,1
;
;device,/close
;
end
