set_plot,'ps'
device,filename='gome2000.ps',xoffset=2,yoffset=2,ysize=24
cartrn=''
;
!p.charthick=2.0
!p.charsize=1.5
!p.thick=2.0
!x.thick=2.0
!y.thick=2.0
!p.multi=[0,0,2,0,0]
;
alfa=fltarr(5,12168)
;
data=fltarr(3,12168)
OPENR,1, 'FTS-corrected-203k.dat'
READF,1,data,format='(f9.2,e12.3,f11.5)'
lamda=1.0/reform(data(0,*))*(10.0^7)
alfa(0,*)=data(1,*)
close,1
;
data=fltarr(3,12168)
OPENR,1, 'FTS-corrected-223k.dat'
READF,1,data,format='(f9.2,e12.3,f11.5)'
alfa(1,*)=data(1,*)
close,1
;
data=fltarr(3,12168)
OPENR,1, 'FTS-corrected-246k.dat'
READF,1,data,format='(f9.2,e12.3,f11.5)'
alfa(2,*)=data(1,*)
close,1
;
data=fltarr(3,12168)
OPENR,1, 'FTS-corrected-280k.dat'
READF,1,data,format='(f9.2,e12.3,f11.5)'
alfa(3,*)=data(1,*)
close,1
;
data=fltarr(3,12168)
OPENR,1, 'FTS-corrected-293k.dat'
READF,1,data,format='(f9.2,e12.3,f11.5)'
alfa(4,*)=data(1,*)
close,1
;
print,alfa(*,10000)
alfa=alfa*2.547*(10.0^19.0)
print,alfa(*,10000)
;
;plot,lamda,alfa(0,*)
;for i=1,3 do oplot,lamda,alfa(i,*)
;read,cartrn
;
;plot,lamda,alfa(0,*),xrange=[300,420],xstyle=1,yrange=[0,2],ystyle=1
;for i=1,3 do oplot,lamda,alfa(i,*)
;read,cartrn
;
plot,lamda,alfa(0,*),xrange=[320,330],xstyle=1,yrange=[0,1.0],ystyle=1, $
  xtitle='Wavelength (nm)',ytitle='(atm-cm)-1', $
  title='GOME 2000 Absorption Coefficients'
xyouts,0.30,0.92,'203, 223, 246, and 280 degrees',/norm
for i=1,3 do oplot,lamda,alfa(i,*)
read,cartrn
;
plot,lamda,alfa(1,*)-alfa(0,*),xrange=[320,330],xstyle=1,yrange=[-0.05,0.1],ystyle=1, $
  xtitle='Wavelength (nm)',ytitle='(atm-cm)-1', $
  title='Absorption Differences'
xyouts,0.27,0.42,'Differences of Adjacent Temperatures',/norm
for i=1,2 do oplot,lamda,alfa(i+1,*)-alfa(i,*)
read,cartrn
;
temp=[203.0,223.0,246.0,280.0,293.0]-273.13
tcofs=fltarr(3,12168)
;
refit=0
if refit eq 1 then begin
;
openw,2,'gome2000.dat'
first=0
cntout=0
for j=0,12167 do begin
  i=12167-j
  tcofs(*,i)=poly_fit(temp(0:3),alfa(0:3,i),2,yfit,yband,sigma,a)
  if first eq 0 then printf,2,lamda(i),tcofs(*,i)
  if first eq 0 then cntout = cntout + 1
neg=where(yfit le 0,ncnt)
if ncnt gt 0 and first eq 0 then begin
  print,i
  first=1
endif
;if i mod 100 eq 0 then begin
;  plot,temp,yfit
;  oplot,temp,alfa(*,i),psym=2
;print,i,lamda(i)
;  read,cartrn
;endif
endfor
close,2
;
ftdata=fltarr(4,cntout)
openr,2,'gome2000.dat'
readf,2,ftdata
close,2
;
ftalf=ftdata(1,*)+ftdata(2,*)*(-50.13)+ftdata(3,*)*(-50.13)^2.0
plot,ftdata(0,*),ftalf,xrange=[320,325],xstyle=1,yrange=[0,0.8],ystyle=1,linestyle=1
oplot,lamda,alfa(1,*),linestyle=1
read,cartrn
alfa=reverse(alfa,2)
lamda=reverse(lamda)
oplot,lamda,alfa(1,*)
read,cartrn
;
delfit=(ftalf-alfa(1,0:9794))/alfa(1,0:9794)*100.0
plot,lamda(0:9794),delfit,yrange=[-5,5],ystyle=1
read,cartrn
;
;delmda=ftdata(0,*)-lamda(0:9794)
;plot,ftdata(0,*),delmda
;
endif
;
device,/close
;
end
