;set_plot,'ps'
;device,filename='spline_bass.ps',xoffset=2,yoffset=2,ysize=24
;!p.multi=[0,0,2,0,0]
cartrn=''
hdr=''
;
;!p.charthick=2.0
;!p.charsize=1.5
;!p.thick=2.0
;!x.thick=2.0
;!y.thick=2.0
;
;  read in v7 bass coefficients data file
;
v7bass=fltarr(6,3047)
file_name='/misc/cgw/source/v7simtoms/BASS_2.DAT'
openr,iunit, file_name, /get_lun
readf,iunit,v7bass
close,iunit
free_lun, iunit
lamda = v7bass(0,*)
;
;  read in tomrad v 2.22 bass coefficients data file
;
v222bass=fltarr(6,1075)
file_name='/misc/cgw/source/v8alpha/DFBASS.DAT'
openr,iunit, file_name, /get_lun
readf,iunit,hdr
readf,iunit,v222bass
close,iunit
free_lun, iunit
lamda222 = v222bass(0,*)
;
;  spline original bass data set from v7 era
;
lmdout=findgen(1601)+2500.0
newdata=fltarr(6,1601)
newdata(0,*)=lmdout
for i=1,5 do begin
  y=reform(v7bass(i,*))
  newdata(i,*)=interpol(y,lamda,lmdout)
  plot,lamda,v7bass(i,*),psym=3
  read,cartrn
  oplot,newdata(0,*),newdata(i,*),psym=2
  read,cartrn
endfor
;
;  extend rho estimated at 400 nm to 410 nm
;
newdata(5,1502:1600)=newdata(5,1501)
;
;  spline rayleigh coeff and rho factors from v222 and compare
;
data222=fltarr(6,1601)
for i=4,5 do begin
  y=reform(v222bass(i,*))
  data222(i,300:1600)=interpol(y,lamda222,lmdout(300:1600))
  plot,lmdout(300:1600),data222(i,300:1600),psym=3,ystyle=16
  read,cartrn
  oplot,newdata(0,300:1600),newdata(i,300:1600),psym=2
  read,cartrn
  plot,lmdout(300:1600),data222(i,300:1600)/newdata(i,300:1600),psym=3,ystyle=16
  read,cartrn
endfor
;
;  create output file in tomrad format
;
;  read in bass coefficients
;    WLVAC         C0           C1           C2           BETA         RHO
; 3.07139E+03  3.88057E+00  1.01524E-02  4.67511E-05  1.09969E+00  3.17000E-02
;
;
output=1
if output eq 1 then begin
;
hdr='    WLVAC         C0           C1           C2           BETA         RHO'
openw,1,'NEWBASS_V8.DAT'
printf,1,hdr
for i=0,1600 do printf,1,newdata(*,i),format='(e12.5,5e13.5)'
close,1
;
endif
;
;device,/close
;
end
