c
        real*8 function fk_bates(w)
c
c input
c w - wavelength in micrometers        
c
c compute the king correction factor using bates 1984 paper
c
        implicit none
        include 'gases.cmn'
        real*8 w
c local
        real*8 fkn2,fko2,fkar,fkco2
        external fkn2,fko2,fkar,fkco2
c
        fk_bates=xn2*fkn2(w)+xo2*fko2(w)+xar*fkar(w)+xco2*fkco2(w)
        return
c
        end
c
        real*8 function fkn2(w)
c
c compute the king correction factor for n2 using bates, 1984
c
c input
c w - wavelength in micrometers
c
        implicit none
        real*8 w,m
c
        fkn2=1.034d0+(3.17d-04)/w/w
        return
        end
c
        real*8 function fko2(w)
c
c compute the king correction factor for o2 using bates, 1984
c
c input
c w - wavelength in micrometers
c
        implicit none
        real*8 w,m
c
        m=1.0d0/w/w
        fko2=1.096d0+(1.385d-03)*m+(1.448d-04)*m*m
        return
        end
c
        real*8 function fkar(w)
c
c compute the king correction factor for ar using bates, 1984
c
c input
c w - wavelength in micrometers
c
        implicit none
        real*8 w
c
        fkar=1.0d0
        return
        end
c
        real*8 function fkco2(w)
c
c compute the king correction factor for co2 using bates, 1984
c
c input
c w - wavelength in micrometers
c
        implicit none
        real*8 w
c
        fkco2=1.15d0
        return
        end
