	real*8 function fkp_bates(w)
c
c compute the effective king correction factor using bates data
c input
c Ref. Bates, (1984), "Rayleigh scattering by air", 
c      Planet Space, Sci., Vol. 32, pp, 785-790.
c input:
c w - wavelength in micrometers        
c
c
	implicit none
        include 'gases.cmn'
        real*8 w
c local
        real*8 sum
        real*8 fkn2,fko2,fkar,fkco2,nairm1_bates
        real*8 nm1_n2,nm1_o2,nm1_ar,nm1_co2
        external fkn2,fko2,fkar,fkco2,nairm1_bates
        external nm1_n2,nm1_o2,nm1_ar,nm1_co2
c
c (nair-1)**2 * fkp = sum over spicies of xi * (ni-1)**2 fki
c  (Eqs. 1,5 & 15 of bates)
c
        sum=xn2*(nm1_n2(w)**2)*fkn2(w)+
     &  xo2*(nm1_o2(w)**2)*fko2(w) +
     &  xar*(nm1_ar(w)**2)*fkar(w) +
     &  xco2*(nm1_co2(w)**2)*fkco2(w)
        fkp_bates=sum/((nairm1_bates(w))**2)
        return
c
        end
