	real*8 function nm1_n2(w)
c compute the index of refraction - 1 of n2 using bates
        implicit none
        real*8 w
c
        if(w.gt.0.468d0)then
          nm1_n2=6855.2d-08 + 3243157.0d-08/(144.0d0-1.0d0/w/w)
        else if(w.lt.0.254)then
          nm1_n2=6998.749d-08 + 3233582.0d-08/(144.0d0-1.0d0/w/w)
        else
          nm1_n2=5989.242d-08 + 3363266.3d-08/(144.0d0-1.0d0/w/w)
        endif
        return
        end
c
	real*8 function nm1_o2(w)
c compute the index of refraction - 1 of o2 using bates
        implicit none
        real*8 w,A,B
c
        if(w.gt.0.546d0)then
          A=21351.1d0
          B=218567.0d0
        else if((w.le.0.546d0).and.(w.gt.0.288d0))then
          A=20564.8d0
          B=248089.9d0
        else if((w.le.0.288d0).and.(w.gt.0.221d0))then
          A=22120.4d0
          B=203187.6d0
        else
          A=23796.7d0
          B=168988.4d0
        endif
        nm1_o2=(A+B/(40.9d0-1.0d0/w/w))*1.0d-08
        return
        end
c
	real*8 function nm1_ar(w)
c compute the index of refraction - 1 of ar using bates
        implicit none
        real*8 w,m,nnm1
c
        m=(1.0d0/(w*1.0d04))**2
        nnm1=5.547d-04*(1.0d0+m*5.15d05+m*m*4.19d11+
     &m*m*m*4.09d17+m*m*m*m*4.32d23)
        nm1_ar=sqrt(nnm1+1)-1.0d0
        return
        end
c
	real*8 function nm1_co2(w)
c compute the index of refraction - 1 of co2 using bates
        implicit none
        real*8 w,m
c
        m=1.0d0/w/w
        nm1_co2=1205.5d-05*(5.79925/(166.175-m)+0.12005d0/(79.609-m)+
     &  0.53334d-02/(56.3064-m)+0.43244d-02/(46.0196-m)+
     &  1.218145d-04/(0.0584738-m))
        return
        end
c
        real*8 function nairm1_bates(w)
c
c input
c w - wavelength in micrometers        
c
c compute the index of refraction using bates
c
        implicit none
        include 'gases.cmn'
        real*8 w
c local
        real*8 nm1_n2,nm1_o2,nm1_ar,nm1_co2
        external nm1_n2,nm1_o2,nm1_ar,nm1_co2
c
        nairm1_bates=xn2*nm1_n2(w)+xo2*nm1_o2(w)+xco2*nm1_co2(w)+
     &xar*nm1_ar(w)
        return
        end
