c
        real*8 function xsec_bates(w)
c
c input
c w - wavelength in micrometers        
c
c compute the rayleigh scattering cross section
c
        implicit none
        include 'gases.cmn'
        real*8 w
        real*8 fkn2,fko2,fkar,fkco2
        real*8 nm1_n2,nm1_o2,nm1_ar,nm1_co2
        external fkn2,fko2,fkar,fkco2
        external nm1_n2,nm1_o2,nm1_ar,nm1_co2
c local
        real*8 N,c1
        common /consts/N,c1
        save /consts/
c
        xsec_bates=(nm1_n2(w)**2)*xn2*fkn2(w)+
     &(nm1_o2(w)**2)*xo2*fko2(w)+
     &(nm1_ar(w)**2)*xar*fkar(w)+
     &(nm1_co2(w)**2)*xco2*fkco2(w)
        xsec_bates=xsec_bates*1.0d-22*c1/N/N/(w**4)
        return
c
        end
c
        real*8 function nsm1(w)
c index of refraction for air at standard pressure (1atm) and temp (15c)
c
c input 
c w - wavelength in micrometers
c
        implicit none
        real*8 w,m
c
        m=1.0d0/w/w
        if(w.gt.0.23d0)then
          nsm1=5791817.0d-08/(238.0185-m)+167909.0d-08/(57.362-m)
        else
          nsm1=8060.51d-08+2480990.0d-08/(132.274-m)+
     &17455.7d-08/(39.32957d0-m)
        endif
        return
        end
c
	blockdata constants
c
        real*8 N,c1
        common /consts/N,c1
c c1=32/3*pi**3 / N/N
c
        data N/2.686754d0/
        data c1/330.7336179d0/
        end
