c
        real*8 function xsec_buch(w)
c
c input
c w - wavelength in micrometers        
c
c compute the rayleigh scattering cross section
c
        implicit none
        real*8 w
        real*8 fkp_bates,nsm1,fkp_bates_tab
        external fkp_bates,nsm1,fkp_bates_tab
c local
        real*8 N,c1,nsns
        common /consts/N,c1
        save /consts/
c
        nsns=(1.0d0+nsm1(w))**2
        xsec_buch=fkp_bates(w)/(w**4)*c1*((nsns-1)/(2.0d0+nsns))**2
c to linearly interpolate the bates Fk table use the following line
c this will reprocude the table in buch.
c        xsec_buch=fkp_bates_tab(w)/(w**4)*c1*((nsns-1)/(2.0d0+nsns))**2
        xsec_buch=xsec_buch*1.0d-22
        return
c
        end
c
        real*8 function nsm1(w)
c index of refraction for air at standard pressure (1atm) and temp (15c)
c
c input 
c w - wavelength in micrometers
c
        implicit none
        real*8 w,m
c
        m=1.0d0/w/w
        if(w.gt.0.23d0)then
          nsm1=5791817.0d-08/(238.0185-m)+167909.0d-08/(57.362-m)
        else
          nsm1=8060.51d-08+2480990.0d-08/(132.274-m)+
     &17455.7d-08/(39.32957d0-m)
        endif
        return
        end
c
	blockdata constants
c
        real*8 N,c1
        common /consts/N,c1
c c1=24*pi**3 / N/N
c
        data N/2.54743d0/
        data c1/114.671724d0/
        end
